import java.io.*;
public class TableConnector{
    public static void main(String[]args){
        try{
            int n=new Integer(args[0]).intValue();
            int m=new Integer(args[1]).intValue();
            FileOutputStream fos=new FileOutputStream("tablecon.txt");
            PrintStream ps=new PrintStream(fos);
            ps.println("MODULE TABLECON{");
            ps.println("IN setkey;");
            ps.println("IN setval;");
            ps.println("IN getval;");
            ps.println("IN getaddr;");
            for(int i=0;i<32;i++){
                ps.println("IN readinkey"+(i+1)+";");
            }
            for(int i=0;i<32;i++){
                ps.println("IN readinval"+(i+1)+";");
            }
            for(int i=0;i<32;i++){
                ps.println("IN readat"+(i+1)+";");
            }
            ps.println("OUT setkeyo;");
            ps.println("OUT setvalo;");
            ps.println("OUT getvalo;");
            ps.println("OUT getaddro;");
            for(int i=0;i<32;i++){
                ps.println("OUT readinkeyo"+(i+1)+";");
            }
            for(int i=0;i<32;i++){
                ps.println("OUT readinvalo"+(i+1)+";");
            }
            for(int i=0;i<32;i++){
                ps.println("OUT readato"+(i+1)+";");
            }
            for(int i=n;i<=m;i++){
                ps.println("table"+i+" memo"+i+";");
            }
            ps.println("CONNECT setkey memo"+n+".setkey;");
            ps.println("CONNECT setval memo"+n+".setval;");
            ps.println("CONNECT getval memo"+n+".getval;");
            ps.println("CONNECT getaddr memo"+n+".getaddr;");
            for(int i=0;i<32;i++){
                ps.println("CONNECT readinkey"+(i+1)+" memo"+n+".readinkey"+(i+1)+";");
            }
            for(int i=0;i<32;i++){
                ps.println("CONNECT readinval"+(i+1)+" memo"+n+".readinval"+(i+1)+";");
            }
            for(int i=0;i<32;i++){
                ps.println("CONNECT readat"+(i+1)+" memo"+n+".readat"+(i+1)+";");
            }
            ps.println("CONNECT memo"+m+".setkeyo setkeyo;");
            ps.println("CONNECT memo"+m+".setvalo setvalo;");
            ps.println("CONNECT memo"+m+".getvalo getvalo;");
            ps.println("CONNECT memo"+m+".getaddro getaddro;");
            for(int i=0;i<32;i++){
                ps.println("CONNECT memo"+m+".readinkeyo"+(i+1)+" readinkeyo"+(i+1)+";");
            }
            for(int i=0;i<32;i++){
                ps.println("CONNECT memo"+m+".readinvalo"+(i+1)+" readinvalo"+(i+1)+";");
            }
            for(int i=0;i<32;i++){
                ps.println("CONNECT memo"+m+".readato"+(i+1)+" readato"+(i+1)+";");
            }
            for(int j=n;j<m;j++){
                ps.println("CONNECT memo"+j+".setkeyo memo"+(j+1)+".setkey;");
                ps.println("CONNECT memo"+j+".setvalo memo"+(j+1)+".setval;");
                ps.println("CONNECT memo"+j+".getvalo memo"+(j+1)+".getval;");
                ps.println("CONNECT memo"+j+".getaddro memo"+(j+1)+".getaddr;");
                for(int i=0;i<32;i++){
                    ps.println("CONNECT memo"+j+".readinkeyo"+(i+1)+" memo"+(j+1)+".readinkey"+(i+1)+";");
                }
                for(int i=0;i<32;i++){
                    ps.println("CONNECT memo"+j+".readinvalo"+(i+1)+" memo"+(j+1)+".readinval"+(i+1)+";");
                }
                for(int i=0;i<32;i++){
                    ps.println("CONNECT memo"+j+".readato"+(i+1)+" memo"+(j+1)+".readat"+(i+1)+";");
                }
            }
            ps.println("}");
            ps.close();
            fos.close();
        }
        catch(Exception e){
        }
    }
}
