import java.io.*;
class TableGenerator{
    public static void main(String[]args){
        try{
            int begin=new Integer(args[0]).intValue();
            int end=new Integer(args[1]).intValue();
            FileOutputStream fos=new FileOutputStream("table.txt");
            PrintStream ps=new PrintStream(fos);
            for(int i=begin;i<=end;i++){
                int n=i;
                int[]bj=new int[32];
                for(int j=0;j<32;j++){
                    bj[j]=n%2;
                    n=n/2;
                }
                ps.println("MODULE table"+i+"{");
                ps.println("IN setkey;");
                ps.println("IN setval;");
                ps.println("IN getval;");
                ps.println("IN getaddr;");
                for(int j=1;j<=32;j++){
                    ps.println("IN readinkey"+j+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("IN readinval"+j+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("IN readat"+j+";");
                }
                ps.println("OUT setkeyo;");
                ps.println("OUT setvalo;");
                ps.println("OUT getvalo;");
                ps.println("OUT getaddro;");
                for(int j=1;j<=32;j++){
                    ps.println("OUT readinkeyo"+j+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("OUT readinvalo"+j+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("OUT readato"+j+";");
                }
                ps.println("INV invin invout;");
                for(int j=0;j<32;j++){
                    if(bj[j]==0){
                        ps.println("INV inv"+(j+1)+"in inv"+(j+1)+"out;");
                    }
                }
                ps.println("GLOBAND glob;");
                ps.println("AND setkeyandin1 setkeyandin2 setkeyandout;");
                ps.println("AND setvalandin1 setvalandin2 setvalandout;");
                ps.println("AND getvalandin1 getvalandin2 getvalandout;");
                ps.println("AND getaddrin1 getaddrin2 getaddrout;");
                ps.println("OR getin1 getin2 getout;");
                ps.println("GLOBAND glob2;");
                ps.println("XORM xorm[32];");
                for(int j=1;j<=32;j++){
                    ps.println("INV invb"+j+"in invb"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("BIT bitin"+j+" bitout"+j+" bitread"+j+" bitset"+j+" 0;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("BIT bitinb"+j+" bitoutb"+j+" bitreadb"+j+" bitsetb"+j+" 0;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("AND aand"+j+"in1 aand"+j+"in2 aand"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("AND band"+j+"in1 band"+j+"in2 band"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("AND cand"+j+"in1 cand"+j+"in2 cand"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("OR or"+j+"in1 or"+j+"in2 or"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("OR bor"+j+"in1 bor"+j+"in2 bor"+j+"out;");
                }
                ps.println("CONSTANT c 0;");
                ps.println("CONSTANT d 1;");
                for(int j=0;j<32;j++){
                    if(bj[j]==0){
                        ps.println("CONNECT readat"+(j+1)+" inv"+(j+1)+"in;");
                        ps.println("CONNECT inv"+(j+1)+"out glob.in"+(j+1)+";");
                    }
                    else{
                        ps.println("CONNECT readat"+(j+1)+" glob.in"+(j+1)+";");
                    }
                }
                ps.println("CONNECT setkey setkeyandin1;");
                ps.println("CONNECT glob.out setkeyandin2;");
                ps.println("CONNECT setval setvalandin1;");
                ps.println("CONNECT glob.out setvalandin2;");
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT d bitread"+j+";");
                    ps.println("CONNECT setkeyandout bitset"+j+";");
                    ps.println("CONNECT readinkey"+j+" bitin"+j+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT readinkey"+j+" xorm["+(j-1)+"].in1;");
                    ps.println("CONNECT bitout"+j+" xorm["+(j-1)+"].in2;");
                    ps.println("CONNECT xorm["+(j-1)+"].out invb"+j+"in;");
                    ps.println("CONNECT invb"+j+"out glob2.in"+j+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT d bitreadb"+j+";");
                    ps.println("CONNECT setvalandout bitsetb"+j+";");
                    ps.println("CONNECT readinval"+j+" bitinb"+j+";");
                    ps.println("CONNECT bitoutb"+j+" aand"+j+"in1;");
                    ps.println("CONNECT getvalandout aand"+j+"in2;");
                }
                for(int j=0;j<32;j++){
                    ps.println("CONNECT getaddrout cand"+(j+1)+"in1;");
                    if(bj[j]==0){
                        ps.println("CONNECT c cand"+(j+1)+"in2;");
                    }
                    else{
                        ps.println("CONNECT d cand"+(j+1)+"in2;");
                    }
                }
                ps.println("CONNECT getval getvalandin1;");
                ps.println("CONNECT glob2.out getvalandin2;");
                ps.println("CONNECT getaddr getaddrin1;");
                ps.println("CONNECT glob2.out getaddrin2;");
                ps.println("CONNECT getvalandout getin1;");
                ps.println("CONNECT getaddrout getin2;");
                ps.println("CONNECT getout invin;");
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT invout band"+j+"in1;");
                    ps.println("CONNECT readinval"+j+" band"+j+"in2;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT aand"+j+"out bor"+j+"in1;");
                    ps.println("CONNECT cand"+j+"out bor"+j+"in2;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT bor"+j+"out or"+j+"in1;");
                    ps.println("CONNECT band"+j+"out or"+j+"in2;");
                    ps.println("CONNECT or"+j+"out readinvalo"+j+";");
                    ps.println("CONNECT readat"+j+" readato"+j+";");
                    ps.println("CONNECT readinkey"+j+" readinkeyo"+j+";");
                }
                ps.println("CONNECT setkey setkeyo;");
                ps.println("CONNECT setval setvalo;");
                ps.println("CONNECT getval getvalo;");
                ps.println("CONNECT getaddr getaddro;");
                ps.println("}");
            }
        }
        catch(Exception e){
        }
    }
}
