import java.awt.*;
import java.io.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import java.util.*;
public class AstroChip extends JFrame implements Runnable,ActionListener{
    Thread t;
    JTextArea ta;
    JScrollPane spta;
    JButton load;
    JButton save;
    JButton build;
    JButton run;
    JButton stop;
    JButton browser;
    JButton xpro32ncore;
    JLabel la;
    JTextArea result;
    JScrollPane spresult;
    JLabel l;
    Module main;
    boolean buildc=false;
    boolean runc=false;
    boolean browserb=false;
    boolean xpro32ncoreb=false;
    Stopper stopper;
    private static final long serialVersionUID = -6111553270310855228L;
    public AstroChip(){
        super("Astro Solutions Semiconductor Software AstroChip");
        pack();
        setSize(640,600);
        stopper=new Stopper();
        t=new Thread(this);
        setLayout(null);
        ta=new JTextArea();
        spta=new JScrollPane(ta);
        load=new JButton("load");
        save=new JButton("save");
        build=new JButton("build");
        run=new JButton("run");
        stop=new JButton("stop");
        la=new JLabel("");
        result=new JTextArea();
        spresult=new JScrollPane(result);
        l=new JLabel("");
        browser=new JButton("MODULE Browser");
        xpro32ncore=new JButton("XPRO32NCORE");
        add(spta);
        add(load);
        add(save);
        add(build);
        add(run);
        add(stop);
        add(la);
        add(spresult);
        add(l);
        add(browser);
        add(xpro32ncore);
        spta.setBounds(10,40,580,300);
        load.setBounds(10,350,80,27);
        save.setBounds(110,350,80,27);
        build.setBounds(210,350,80,27);
        run.setBounds(310,350,80,27);
        stop.setBounds(410,350,80,27);
        la.setBounds(510,350,80,27);
        spresult.setBounds(10,380,580,100);
        l.setBounds(10,480,80,27);
        browser.setBounds(10,510,280,27);
        xpro32ncore.setBounds(300,510,280,27);
        load.addActionListener(this);
        save.addActionListener(this);
        build.addActionListener(this);
        run.addActionListener(this);
        stop.addActionListener(this);
        browser.addActionListener(this);
        xpro32ncore.addActionListener(this);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        t.start();
        setVisible(true);
    }
    public void run(){
        while(true){
            try{
                getLine();
                Thread.sleep(100);
                if(browserb){
                    browserb=false;
                    if(main!=null){
                        new ModuleBrowser(main,main);
                    }
                    else{
                        setTitle("compiled source required");
                    }
                }
                if(xpro32ncoreb){
                    xpro32ncoreb=false;
                    new NcoreCreator(this,main);
                }
                if(buildc){
                    stopper.stop=false;
                    buildc=false;
                    result.append("starting\n");
                    String fs=ta.getText();
//                    fs=Compiler.filter(fs);
                    TokenList[]tl=Compiler.compile(fs,result);
                    result.append("tokenlist generated\n");
                    main=Compiler.build1(tl,result,stopper);
                    result.append("compiled...");
                    if(main!=null){
                        result.append("searching signals without source...\n");
                        try{
                            Compiler.findOpen(main,result);
                        }
                        catch(Exception eb){
                        }
                    }
                    else{
                        result.append("no MODULE main built\n");
                    }
                    result.append("end\n");
                }
                if(runc){
//FileOutputStream fos=new FileOutputStream("log.txt");
//PrintStream ps=new PrintStream(fos);
                    stopper.stop=false;
                    runc=false;
                    int cyc=0;
                    AllModules am=main.am;
                    while(!stopper.stop){
                        am.schalt();
                        main.setfalse();
                        Curver curver=new Curver(this,result,stopper);
                        Constant[]constants=am.constants;
                        Module[]modules=am.modules;
                        for(int i=0;i<constants.length;i++){
                            curver.addElemBase(new Holder(constants[i]));
                        }
                        for(int i=0;i<modules.length;i++){
                            if(modules[i].cycles>=0){
                                curver.addElemBase(new Holder(modules[i],"OUT"));
                            }
                        }
int bonus=0;
                        while(curver.isNotEmpty()&&!stopper.stop){
                            curver.process();
//System.out.println("xxx1");
                            curver.delvisited();
bonus++;
//System.out.println("bonus: "+bonus);
if(bonus%3000==0){
curver.disp=true;
}
else curver.disp=false;
                        }
//System.out.println("xxx");
                        if(!stopper.stop)main.printBits(result);
setTitle("cycle number: "+cyc);
                        try{
                            if(!stopper.stop)main.view(result,"main");
                        }
                        catch(Exception eb){
                        }
                        if(!stopper.stop)result.append("cycle "+cyc+" completed\n");
                  //      if(!stopper.stop)result.append("cycle "+cyc+" completed\n");
                        cyc++;
                    }
                    result.append("stopped, last cycle: "+(cyc-1)+"\n");
//                    fos.close();
                }
            }
            catch(Exception e){
                e.printStackTrace(System.out);
            };
        }
    }
    public void getLine(){
        int caret=ta.getCaretPosition();
        String tocount=ta.getText().substring(0,caret);
        int l=0;
        for(int i=0;i<tocount.length();i++){
            String str=tocount.substring(i,i+1);
            byte[]by=str.getBytes();
            if(by[0]==10){
                l++;
            }
        }
        la.setText("line "+(l+1));
    }
    public void actionPerformed(ActionEvent ae){
        if(ae.getSource()==browser){
            browserb=true;
        }
        if(ae.getSource()==xpro32ncore){
            xpro32ncoreb=true;
        }
        if(ae.getSource()==load){
            JFileChooser fd=new JFileChooser();
            FileNameExtensionFilter filter=new FileNameExtensionFilter("TXT AstroChip definitions","txt");
            fd.setFileFilter(filter);
            int ret=fd.showOpenDialog(this);
            File filo=null;
            if(ret==JFileChooser.APPROVE_OPTION){
                filo=fd.getSelectedFile();
            }
            else{
                result.append("fileselect load error\n");
                return;
            }
            String fname=filo.getAbsolutePath();
            ta.setText("");
            try{
                FileInputStream fis=new FileInputStream(fname);
                long longo=filo.length();
                byte[]byto=new byte[(int)longo];
                byte[]bym=new byte[1024];
                int i=0;
                int erc=0;
                while(i<longo&&erc<100){
                    int rea=fis.read(bym,0,1024);
                    if(rea!=-1){
                        for(int j=0;j<rea;j++){
                            byto[i+j]=bym[j];
                        }
                        i=i+rea;
                        erc=0;
                    }
                    else{
                        erc++;
                    }
                }
                if(erc>=100){
                    ta.setText("error loading file: "+fname+"\n");
                }
                else{
                    ta.append(new String(byto));
                }
                fis.close();
            }
            catch(Exception e){
                result.append("\nerror loading "+fname+"\n");
            }
        }
        if(ae.getSource()==save){
            JFileChooser fds=new JFileChooser();
            FileNameExtensionFilter filters=new FileNameExtensionFilter("TXT AstroChip definitions","txt");
            fds.setFileFilter(filters);
            int rets=fds.showSaveDialog(null);
            File f=null;
            String fname2=null;
            if(rets==JFileChooser.APPROVE_OPTION){
                f=fds.getSelectedFile();
                fname2=f.getAbsolutePath();
            }
            if(fname2==null){
                result.append("fileselect save error\n");
                return;
            }
            try{
                FileOutputStream fos=new FileOutputStream(fname2);
                PrintStream ps=new PrintStream(fos);
                ps.println(ta.getText());
                fos.close();
            }
            catch(Exception fexc){
                fexc.printStackTrace(System.out);
                result.append("\nerror saving "+fname2+"\n");
            }
        }
        if(ae.getSource()==build){
            buildc=true;
        }
        if(ae.getSource()==run){
            runc=true;
        }
        if(ae.getSource()==stop){
            stopper.stop=true;
        }
    }
    public static void main(String[]args){
        new AstroChip();
    }
}
class Compiler{
    public static Module build1(TokenList[] tl,JTextArea result,Stopper stopper){
        int startline=-1;
        for(int i=0;i<tl.length;i++){
            String s1=tl[i].first.next.value;
            if(s1.equals("MODULE")){
                String s2=tl[i].first.next.next.value;
                if(s2.equals("main"))startline=i;
            }
        }
//System.out.println("Startline: "+startline);
        Module main=new Module("main");
        main.typename="main";
        AllModules am=new AllModules();
        am.add(main);
        build2(tl,main,startline+1,am,result,stopper);
        main.am=am;
        if(stopper.stop){
            result.append("aborted\n");
        }
        return main;
    }
    public static void build2(TokenList[]tl,Module module,int startline,AllModules am,JTextArea result,Stopper stopper){
        boolean running=true;
        int line=startline;
        Constant constant=null;
        Bit bit=null;
        Or or=null;
        And and=null;
        Xor xor=null;
        Nand nand=null;
        Inv inv=null;
        PLA pla=null;
        Conn con=null;
        For forbase=null;
        For forcur=null;
        while(running){
System.out.println("line: "+line);
            if(stopper.stop){
                return;
            }
            Token t1=tl[line].first.next;
            String s3=t1.value;
            if(s3.equals("CONSTANT")){
                constant=new Constant();
                if(t1.next.nr!=2||t1.next.next.nr!=2){
                    result.append("CONSTANT missing parameter in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                constant.outname=new String(t1.next.value);
                try{
                    constant.value=new Integer(t1.next.next.value).intValue();
                }
                catch(Exception e1){
                    result.append("CONSTANT value illegal in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                if(constant.value<0||constant.value>1){
                    result.append("CONSTANT value out of range in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                constant.parent=module;
                module.addConstant(constant);
                am.addConstant(constant);
                line++;
            }
            else if(s3.equals("OR")){
                or=new Or();
                if(t1.next.nr!=2||t1.next.next.nr!=2||t1.next.next.next.nr!=2){
                    result.append("missing OR parameter in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                or.in1name=t1.next.value;
                or.in2name=t1.next.next.value;
                or.outname=t1.next.next.next.value;
                or.parent=module;
                module.addOr(or);
                line++;
            }
            else if(s3.equals("AND")){
                and=new And();
                if(t1.next.nr!=2||t1.next.next.nr!=2||t1.next.next.next.nr!=2){
                    result.append("missing AND parameter in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                and.in1name=t1.next.value;
                and.in2name=t1.next.next.value;
                and.outname=t1.next.next.next.value;
                and.parent=module;
                module.addAnd(and);
                line++;
            }
            else if(s3.equals("XOR")){
                xor=new Xor();
                if(t1.next.nr!=2||t1.next.next.nr!=2||t1.next.next.next.nr!=2){
                    result.append("missing XOR parameter in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                xor.in1name=t1.next.value;
                xor.in2name=t1.next.next.value;
                xor.outname=t1.next.next.next.value;
                xor.parent=module;
                module.addXor(xor);
                line++;
            }
            else if(s3.equals("NAND")){
                nand=new Nand();
                if(t1.next.nr!=2||t1.next.next.nr!=2||t1.next.next.next.nr!=2){
                    result.append("missing NAND parameter in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                nand.in1name=t1.next.value;
                nand.in2name=t1.next.next.value;
                nand.outname=t1.next.next.next.value;
                nand.parent=module;
                module.addNand(nand);
                line++;
            }
            else if(s3.equals("INV")){
                inv=new Inv();
                if(t1.next.nr!=2||t1.next.next.nr!=2){
                    result.append("missing INV parameter in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                inv.inname=t1.next.value;
                inv.outname=t1.next.next.value;
                inv.parent=module;
                module.addInv(inv);
                line++;
            }
            else if(s3.equals("BIT")){
                bit=new Bit();
                if(t1.next.nr!=2||t1.next.next.nr!=2||t1.next.next.next.nr!=2||t1.next.next.next.next.nr!=2||t1.next.next.next.next.next.nr!=2){
                    result.append("missing BIT parameter in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                bit.inname=t1.next.value;
                bit.outname=t1.next.next.value;
                bit.readname=t1.next.next.next.value;
                bit.setname=t1.next.next.next.next.value;
                try{
                    bit.value=new Integer(t1.next.next.next.next.next.value).intValue();
                }
                catch(Exception e){
                    result.append("illegal BIT value in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                if(bit.value<0||bit.value>1){
                    result.append("illegal BIT value in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                bit.parent=module;
                module.addBit(bit);
                line++;
            }
            else if(s3.equals("CYCLE")){
                if(t1.next.nr!=2){
                    result.append("missing CYCLE parameter in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                int cycles=new Integer(t1.next.value).intValue();
                if(cycles<0){
                    result.append("illegal CYCLE parameter in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                module.cycles=cycles;
                line++;
            }
            else if(s3.equals("IN")){
                if(t1.next.nr!=2){
                    result.append("missing IN parameter in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                module.addInname(t1.next.value);
                line++;
            }
            else if(s3.equals("OUT")){
                if(t1.next.nr!=2){
                    result.append("missing OUT parameter in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                module.addOutname(t1.next.value);
                line++;
            }
            else if(s3.equals("PLA")){
                if(t1.next.nr!=2||t1.next.next.nr!=2||t1.next.next.next.nr!=2){
                    result.append("missing PLA parameter in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                String planame=new String(t1.next.value);
                int incount=0;
                int outcount=0;
                try{
                    incount=new Integer(t1.next.next.value).intValue();
                    outcount=new Integer(t1.next.next.next.value).intValue();
                }
                catch(Exception e){
                    result.append("illegal PLA dimension value in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                PLAData pladata=new PLAData(planame,incount,outcount);
                line++;
                while(!tl[line].first.next.value.equals("PLA-END")){
                    Token t2=tl[line].first.next;
                    if(t2.nr!=2||t2.next.nr!=2){
                        result.append("missing PLA parameter in line "+tl[line].line+": "+tl[line].content+"\n");
                    }
                    try{
//                        int a=getValue(t2.value);
//                        int b=getValue(t2.next.value);
                        pladata.addRow(t2.value,t2.next.value);
                    }
                    catch(Exception e){
                        result.append("illegal PLA table element in line "+tl[line].line+": "+tl[line].content+"\n");
                    }
                    line++;
                }
                line++;
                pla=pladata.getPLA();
                pla.parent=module;
                module.addPLA(pla);
            }
            else if(s3.equals("FOR")){
                if(t1.next.nr!=2||t1.next.next.nr!=2){
                    result.append("missing FOR parameter in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                String var=t1.next.value;
                int n=0;
                try{
                    n=new Integer(t1.next.next.value).intValue();
                }
                catch(Exception e){
                    result.append("illegal FOR end value in line "+tl[line].line+": "+tl[line].content+"\n");
                }
                For newf=new For();
                newf.var=var;
                newf.n=n;
                newf.i=0;
                newf.line=line;
                if(forcur==null){
                    forcur=newf;
                    forbase=newf;
                }
                else{
                    forcur.next=newf;
                    newf.fore=forcur;
                    forcur=newf;
                }
                line++;
            }
            else if(s3.equals("CONNECT")){
try{
                con=new Conn();
                String left="";
                boolean moduleleft=false;
                Token t2=t1.next;
                left=left+t2.value;
                Token t3=t2.next;
                Token t7=t3;
                if(t3.nr==7){
                    moduleleft=true;
                    left=left+".";
                    Token t4=t3.next;
                    left=left+t4.value;
                    t7=t4.next;
                }
                if(t3.nr==5){
                    moduleleft=true;
                    Token t5=t3.next;
                    String testv=t5.value;
                    int val=0;
                    try{
                        val=new Integer(testv).intValue();
                    }
                    catch(Exception especial){
                        For fcur=forcur;
                        while(fcur!=null){
                            if(fcur.var.equals(testv)){
                                val=fcur.i;
                            }
                            fcur=fcur.fore;
                        }
                    };
                    left=left+"["+val+"].";
                    Token t6=t5.next.next.next;
                    left=left+t6.value;
                    t7=t6.next;
                }
                String right="";
                boolean moduleright=false;
                right=right+t7.value;
                Token t3b=t7.next;
                if(t3b.nr==7){
                    moduleright=true;
                    right=right+".";
                    Token t4b=t3b.next;
                    right=right+t4b.value;
                }
                if(t3b.nr==5){
                    moduleright=true;
                    Token t5b=t3b.next;
                    String testvb=t5b.value;
                    int valb=0;
                    try{
                        valb=new Integer(testvb).intValue();
                    }
                    catch(Exception especial2){
                        For fcurb=forcur;
                        while(fcurb!=null){
                            if(fcurb.var.equals(testvb)){
                                valb=fcurb.i;
                            }
                            fcurb=fcurb.fore;
                        }
                    }
                    right=right+"["+valb+"].";
                    Token t6b=t5b.next.next.next;
                    right=right+t6b.value;
                }
                con.left=left;
                con.right=right;
                if(moduleleft){
                    con.sourcetype="MODULE";
                }
                else{
                    con.sourcetype=module.getType(left);
                }
                if(moduleright){
                    con.targettype="MODULE";
                }
                else{
                    con.targettype=module.getType(right);
                }
                module.addCon(con);
                if(con.sourcetype.equals("")||con.sourcetype.equals("NOTFOUND")||con.targettype.equals("")||con.targettype.equals("NOTFOUND")){
                    throw new Exception("CONNECT Exception");
                }
                if(con.sourcetype.equals("MODULE")){
                    String name=con.left;
                    int ind=name.indexOf(".");
                    String lname=name.substring(0,ind);
                    String rname=name.substring(ind+1);
                    boolean okb=false;
                    for(int i=0;i<module.modules.length;i++){
                        if(lname.equals(module.modules[i].name)){
                            String[]outname=module.modules[i].outname;
                            for(int j=0;j<outname.length;j++){
                                if(rname.equals(outname[j])){
                                    okb=true;
                                }
                            }
                        }
                    }
                    if(!okb){
                        result.append("MODULE interface not found\n");
                        throw(new Exception("MODULE ERROR"));
                    }
                }
                if(con.targettype.equals("MODULE")){
                    String name2=con.right;
                    int ind2=name2.indexOf(".");
                    String lname2=name2.substring(0,ind2);
                    String rname2=name2.substring(ind2+1);
                    boolean okb2=false;
                    for(int i=0;i<module.modules.length;i++){
                        if(lname2.equals(module.modules[i].name)){
                            String[]inname=module.modules[i].inname;
                            for(int j=0;j<inname.length;j++){
                                if(rname2.equals(inname[j])){
                                    okb2=true;
                                }
                            }
                        }
                    }
                    if(!okb2){
                        result.append("MODULE interface not found\n");
                        throw(new Exception("MODULE ERROR"));
                    }
                }
                line++;
}
catch(Exception e){
    result.append("CONNECT parameter error in line "+tl[line].line+": "+tl[line].content+"\n");
    line++;
}
            }
            else if(t1.nr==4){
                if(forcur==null){
                    running=false;
                }
                else{
                    forcur.i=forcur.i+1;
                    if(forcur.i==forcur.n){
                        forcur=forcur.fore;
                        line++;
                    }
                    else{
                        line=forcur.line+1;
                    }
                }
            }
            else{
                String typename=new String(s3);
                String name=new String(t1.next.value);
                int nr=t1.next.next.nr;
                if(nr==1){
                    Module single=new Module(name);
                    single.typename=new String(typename);
                    int startl=-1;
                    for(int i=0;i<tl.length;i++){
                        if(stopper.stop){
                            return;
                        }
                        if(tl[i].first.next.value.equals("MODULE")){
                            if(tl[i].first.next.next.value.equals(typename)){
                                startl=i+1;
                            }
                        }
                    }
                    if(startl==0){
                        result.append("MODULE not found in line "+tl[line].line+": "+tl[line].content+"\n");
                    }
                    Module curm=module;
                    boolean doub=false;
                    while(curm!=null){
                        if(curm.typename.equals(typename)){
                            doub=true;
                        }
                        curm=curm.parent;
                    }
                    if(doub){
                        result.append("ERROR infinite recursive definition: "+typename+"\n");
                    }
                    else{
                        build2(tl,single,startl,am,result,stopper);
                        am.add(single);
                        single.parent=module;
                        module.addModule(single);
                    }
                }
                else if(nr==5){
                    int number=new Integer(t1.next.next.next.value).intValue();
                    int startl=-1;
                    for(int i=0;i<tl.length;i++){
                        if(tl[i].first.next.value.equals("MODULE")){
                            if(tl[i].first.next.next.value.equals(typename)){
                                startl=i+1;
                            }
                        }
                    }
                    if(startl==0){
                        result.append("ARRAY MODULE not found in line "+tl[line].line+": "+tl[line].content+"\n");
                    }
                    Module curm2=module;
                    boolean doub2=false;
                    while(curm2!=null){
                        if(curm2.typename.equals(typename)){
                            doub2=true;
                        }
                        curm2=curm2.parent;
                    }
                    if(doub2){
                        result.append("ERROR infinite recursive definition: "+typename+"\n");
                    }
                    else{
                        for(int j=0;j<number;j++){
                            if(stopper.stop){
                                return;
                            }
                            Module one=new Module(name+"["+j+"]");
                            one.modulearrayb=true;
                            one.modulearraysize=number;
                            one.typename=new String(typename);
                            build2(tl,one,startl,am,result,stopper);
                            one.parent=module;
                            module.addModule(one);
                            am.add(one);
                        }
                    }
                }
                line++;
            }
        }
    }
    public static int getValue(String a){
        int ret=0;
        int n=a.length();
        for(int i=n-1;i>=0;i--){
            String curs=a.substring(i,i+1);
            ret=ret+new Integer(curs).intValue();
            ret=ret*2;
        }
        ret=ret/2;
        return ret;
    }
    public static void findOpen(Module m,JTextArea result){
        for(int i=0;i<m.ands.length;i++){
            boolean found1=false;
            boolean found2=false;
            for(int j=0;j<m.cons.length;j++){
                if(m.ands[i].in1name.equals(m.cons[j].right)){
                    found1=true;
                }
                if(m.ands[i].in2name.equals(m.cons[j].right)){
                    found2=true;
                }
            }
            if(!found1){
                result.append("no signal to "+m.ands[i].in1name+" in MODULE "+m.name+"\n");
            }
            if(!found2){
                result.append("no signal to "+m.ands[i].in2name+" in MODULE "+m.name+"\n");
            }
        }
        for(int i=0;i<m.ors.length;i++){
            boolean found1=false;
            boolean found2=false;
            for(int j=0;j<m.cons.length;j++){
                if(m.ors[i].in1name.equals(m.cons[j].right)){
                    found1=true;
                }
                if(m.ors[i].in2name.equals(m.cons[j].right)){
                    found2=true;
                }
            }
            if(!found1){
                result.append("no signal to "+m.ors[i].in1name+" in MODULE "+m.name+"\n");
            }
            if(!found2){
                result.append("no signal to "+m.ors[i].in2name+" in MODULE "+m.name+"\n");
            }
        }
        for(int i=0;i<m.xors.length;i++){
            boolean found1=false;
            boolean found2=false;
            for(int j=0;j<m.cons.length;j++){
                if(m.xors[i].in1name.equals(m.cons[j].right)){
                    found1=true;
                }
                if(m.xors[i].in2name.equals(m.cons[j].right)){
                    found2=true;
                }
            }
            if(!found1){
                result.append("no signal to "+m.xors[i].in1name+" in MODULE "+m.name+"\n");
            }
            if(!found2){
                result.append("no signal to "+m.xors[i].in2name+" in MODULE "+m.name+"\n");
            }
        }
        for(int i=0;i<m.nands.length;i++){
            boolean found1=false;
            boolean found2=false;
            for(int j=0;j<m.cons.length;j++){
                if(m.nands[i].in1name.equals(m.cons[j].right)){
                    found1=true;
                }
                if(m.nands[i].in2name.equals(m.cons[j].right)){
                    found2=true;
                }
            }
            if(!found1){
                result.append("no signal to "+m.nands[i].in1name+" in MODULE "+m.name+"\n");
            }
            if(!found2){
                result.append("no signal to "+m.nands[i].in2name+" in MODULE "+m.name+"\n");
            }
        }
        for(int i=0;i<m.invs.length;i++){
            boolean found1=false;
            for(int j=0;j<m.cons.length;j++){
                if(m.invs[i].inname.equals(m.cons[j].right)){
                    found1=true;
                }
            }
            if(!found1){
                result.append("no signal to "+m.invs[i].inname+" in MODULE "+m.name+"\n");
            }
        }
        for(int i=0;i<m.bits.length;i++){
            boolean found1=false;
            boolean found2=false;
            boolean found3=false;
            for(int j=0;j<m.cons.length;j++){
                if(m.bits[i].setname.equals(m.cons[j].right)){
                    found1=true;
                }
                if(m.bits[i].readname.equals(m.cons[j].right)){
                    found2=true;
                }
                if(m.bits[i].inname.equals(m.cons[j].right)){
                    found3=true;
                }
            }
            if(!found1){
                result.append("no signal to "+m.bits[i].setname+" in MODULE "+m.name+"\n");
            }
            if(!found2){
                result.append("no signal to "+m.bits[i].readname+" in MODULE "+m.name+"\n");
            }
            if(!found3){
                result.append("no signal to "+m.bits[i].inname+" in MODULE "+m.name+"\n");
            }
        }
        for(int i=0;i<m.plas.length;i++){
            boolean[]found=new boolean[m.plas[i].incount];
            for(int j=0;j<m.cons.length;j++){
                for(int k=0;k<m.plas[i].incount;k++){
                    if(m.cons[j].right.equals(m.plas[i].name+k)){
                        found[k]=true;
                    }
                }
            }
            for(int k=0;k<found.length;k++){
                if(!found[k]){
                    result.append("no signal to "+m.plas[i].name+k+" in MODULE "+m.name+"\n");
                }
            }
        }
        for(int i=0;i<m.modules.length;i++){
            for(int j=0;j<m.modules[i].inname.length;j++){
                boolean found=false;
                for(int k=0;k<m.cons.length;k++){
                    if(m.cons[k].right.equals(m.modules[i].name+"."+m.modules[i].inname[j])){
                        found=true;
                    }
                }
                if(!found){
                    result.append("no signal to "+m.modules[i].name+"."+m.modules[i].inname[j]+" in MODULE "+m.name+"\n");
                }
            }
        }
        for(int i=0;i<m.modules.length;i++){
            findOpen(m.modules[i],result);
        }
    }
    public static String getString(String fname){
        String fstring="";
        try{
            FileInputStream fis=new FileInputStream(fname);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String ins="";
            while((ins=dis.readLine())!=null){
                fstring=fstring+ins+"\n";
            }
        }
        catch(Exception e){};
        return fstring;
    }
    public static String filter(String fstring){
        String ret="";
        for(int i=0;i<fstring.length();i++){
            String str=fstring.substring(i,i+1);
            byte[]by=str.getBytes();
            if(by[0]==13||by[0]==10){
            }
            else{
                ret=ret+str;
            }
        }
        return ret;
    }
    public static TokenList[] compile(String fstring,JTextArea result){
        try{
            TokenHolder th=new TokenHolder();
            int flen=fstring.length();
            int pos=0;
            TokenList tl=new TokenList();
            String label="";
            int lino=1;
            String content="";
            while(pos<flen){
                String str=fstring.substring(pos,pos+1);
                if(str.equals(";")){
                    content=content+";";
                    tl.finalo(new String(content),lino);
                    content="";
                    th.add(tl);
                    tl=new TokenList();
                    pos++;
                }
                else if("{".equals(str)){
                    Token t1=new Token(3,"");
                    tl.add(t1);
                    content=content+"{";
                    tl.finalo(new String(content),lino);
                    content="";
                    th.add(tl);
                    tl=new TokenList();
                    pos++;
                }
                else if("}".equals(str)){
                    if(tl.first.next!=null){
                        content=content+"}";
                        tl.finalo(new String(content),lino);
                        content="";
                        th.add(tl);
                        tl=new TokenList();
                    }
                    Token t2=new Token(4,"");
                    tl.add(t2);
                    content=content+"}";
                    tl.finalo(new String(content),lino);
                    content="";
                    th.add(tl);
                    tl=new TokenList();
                    pos++;
                }
                else if("[".equals(str)){
                    Token t3=new Token(5,"");
                    tl.add(t3);
                    pos++;
                }
                else if("]".equals(str)){
                    Token t4=new Token(6,"");
                    tl.add(t4);
                    pos++;
                }
                else if(".".equals(str)){
                    Token t7=new Token(7,"");
                    tl.add(t7);
                    pos++;
                }
                else if(" ".equals(str)){
                    pos++;
                }
                else{
                    byte[]by=str.getBytes();
                    if(by[0]!=10&&by[0]!=13){
                        label=label+str;
                        if(pos<flen-1){
                            String str2=fstring.substring(pos+1,pos+2);
                            if(str2.equals(" ")||str2.equals("{")||str2.equals("}")||str2.equals("[")||str2.equals("]")||str2.equals(";")||str2.equals(".")){
                                Token t5=new Token(2,new String(label));
                                tl.add(t5);
                                label="";
                            }
//                            while(str2.equals(" ")&&pos<flen-1){
//                                pos++;
//                                str2=fstring.substring(pos+1,pos+2);
//                            }
                            pos++;
                        }
                        else{
                            Token t6=new Token(2,new String(label));
                            tl.add(t6);
                            tl.finalo(new String(content),lino);
                            content="";
                            th.add(tl);
                            pos++;
                        }
                    }
                    else{
                        pos++;
                    }
                }
                byte[]bo=str.getBytes();
                if(bo[0]==10){
                    lino++;
                }
                if(bo[0]!=13&&bo[0]!=10&&!str.equals(";")&&!str.equals("{")&&!str.equals("}")){
                    content=content+str;
                }
            }
            return th.tl;
        }
        catch(Exception e){};
        return null;
    }
}
class For{
    For next;
    For fore;
    int n;
    int i;
    String var;
    int line;
}
class TokenHolder{
    TokenList[]tl=new TokenList[0];
    public TokenHolder(){
    }
    public void add(TokenList t){
        int n=tl.length;
        TokenList[]tl2=new TokenList[n+1];
        for(int i=0;i<n;i++){
            tl2[i]=tl[i];
        }
        tl2[n]=t;
        tl=tl2;
    }
}
class TokenList{
    Token first;
    Token current;
    int line;
    String content;
    public TokenList(){
        first=new Token(1,"");
        current=first;
    }
    public void add(Token t){
        current.next=t;
        t.fore=current;
        current=current.next;
    }
    public void finalo(String content,int line){
        current.next=new Token(1,"");
        current=current.next;
        this.content=content;
        this.line=line;
    }
}
class Token{
    Token fore;
    Token next;
    int nr;
    String value;
    public Token(int nr,String value){
        this.nr=nr;
        this.value=value;
    }
}
class And{
    Module parent;
    int in1;
    int in2;
    int out;
    String in1name;
    String in2name;
    String outname;
    boolean in1visited;
    boolean in2visited;
    boolean visited;
    boolean view=false;
    public void setfalse(){
        in1visited=false;
        in2visited=false;
        visited=false;
    }
    public void view(JTextArea result,String path){
        result.append("AND "+in1name+"("+in1+") "+in2name+"("+in2+") "+outname+"("+out+") path: "+path+"\n");
    }
}
class Or{
    Module parent;
    int in1;
    int in2;
    int out;
    String in1name;
    String in2name;
    String outname;
    boolean in1visited;
    boolean in2visited;
    boolean visited;
    boolean view=false;
    public void setfalse(){
        in1visited=false;
        in2visited=false;
        visited=false;
    }
    public void view(JTextArea result,String path){
        result.append("OR "+in1name+"("+in1+") "+in2name+"("+in2+") "+outname+"("+out+") path: "+path+"\n");
    }
}
class Xor{
    Module parent;
    int in1;
    int in2;
    int out;
    String in1name;
    String in2name;
    String outname;
    boolean in1visited;
    boolean in2visited;
    boolean visited;
    boolean view=false;
    public void setfalse(){
        in1visited=false;
        in2visited=false;
        visited=false;
    }
    public void view(JTextArea result,String path){
        result.append("XOR "+in1name+"("+in1+") "+in2name+"("+in2+") "+outname+"("+out+") path: "+path+"\n");
    }
}
class Nand{
    Module parent;
    int in1;
    int in2;
    int out;
    String in1name;
    String in2name;
    String outname;
    boolean in1visited;
    boolean in2visited;
    boolean visited;
    boolean view=false;
    public void setfalse(){
        in1visited=false;
        in2visited=false;
        visited=false;
    }
    public void view(JTextArea result,String path){
        result.append("NAND "+in1name+"("+in1+") "+in2name+"("+in2+") "+outname+"("+out+") path: "+path+"\n");
    }
}
class Inv{
    Module parent;
    int in;
    int out;
    String inname;
    String outname;
    boolean invisited;
    boolean visited;
    boolean view=false;
    public void setfalse(){
        invisited=false;
        visited=false;
    }
    public void view(JTextArea result,String path){
        result.append("INV "+inname+"("+in+") "+outname+"("+out+") path: "+path+"\n");
    }
}
class Bit{
    Module parent;
    int value;
    int set;
    int read;
    int in;
    int out;
    String setname;
    String readname;
    String inname;
    String outname;
    boolean setvisited;
    boolean readvisited;
    boolean invisited;
    boolean visited;
    boolean view=false;
    public void setfalse(){
        setvisited=false;
        readvisited=false;
        invisited=false;
        visited=false;
    }
    public void view(JTextArea result,String path){
        result.append("BIT "+setname+"("+set+") "+readname+"("+read+") "+inname+"("+in+") "+outname+"("+out+") VALUE: "+value+" path: "+path+"\n");
    }
}
class Constant{
    Module parent;
    int value;
    String outname;
    boolean visited;
    boolean view=false;
    public void setfalse(){
        visited=false;
    }
    public void view(JTextArea result,String path){
        result.append("CONSTANT "+outname+"="+value+" "+path+"\n");
    }
}
class PLAData{
    String name;
    int incount;
    int outcount;
    String[]intable=new String[0];
    String[]outtable=new String[0];
    public PLAData(String name,int incount,int outcount){
        this.name=name;
        this.incount=incount;
        this.outcount=outcount;
    }
    public void addRow(String a,String b){
        int n=intable.length;
        String[]intable2=new String[n+1];
        String[]outtable2=new String[n+1];
        for(int i=0;i<n;i++){
            intable2[i]=intable[i];
            outtable2[i]=outtable[i];
        }
        intable2[n]=a;
        outtable2[n]=b;
        intable=intable2;
        outtable=outtable2;
    }
    public PLA getPLA(){
        PLA ret=new PLA(name,incount,outcount,intable,outtable);
        return ret;
    }
}
class PLA{
    String name;
    Module parent;
    int incount;
    int outcount;
    int[]in;
    int[]out;
    String[]intable;
    String[]outtable;
    boolean[]invisited;
    boolean visited;
    boolean view=false;
    public PLA(String name,int incount,int outcount,String[]intable,String[]outtable){
        this.name=name;
        this.incount=incount;
        this.outcount=outcount;
        in=new int[incount];
        invisited=new boolean[incount];
        out=new int[outcount];
        this.intable=intable;
        this.outtable=outtable;
    }
    public void setfalse(){
        visited=false;
        invisited=new boolean[incount];
    }
    public void getResult(){
        String invalue="";
        for(int i=0;i<incount;i++){
            invalue=invalue+in[i];
        }
        String outvalue="";
        for(int i=0;i<intable.length;i++){
            if(invalue.equals(intable[i]))outvalue=outtable[i];
        }
        if(outvalue.equals("")){
            for(int i=0;i<outcount;i++){
                outvalue=outvalue+"0";
            }
        }
        for(int i=0;i<outcount;i++){
            String outistr=outvalue.substring(i,i+1);
            out[i]=new Integer(outistr).intValue();
        }
    }
    public static int powerof2(int n){
        if(n==0)return 1;
        else return 2*powerof2(n-1);
    }
    public void view(JTextArea result,String path){
        result.append("PLA "+name+" IN: ");
        for(int i=0;i<in.length;i++){
            result.append(""+in[i]);
        }
        result.append(" OUT: ");
        for(int i=0;i<out.length;i++){
            result.append(""+out[i]);
        }
        result.append(" path: "+path+"\n");
    }
}
class Module{
    String name;
    String typename;
    boolean modulearrayb=false;
    int modulearraysize=1;
    AllModules am;
    Module parent;
    int[]in=new int[0];
    int incount;
    String[]inname=new String[0];
    int[]out=new int[0];
    int outcount;
    String[]outname=new String[0];
    int cycles;
    int curcycle;
    int[]nextout=new int[0];
    boolean[]visited=new boolean[0];
    boolean[]outvisited=new boolean[0];
    Module[]modules=new Module[0];
    int modulescount;
    PLA[]plas=new PLA[0];
    int placount;
    Constant[]constants=new Constant[0];
    int constantcount;
    Bit[]bits=new Bit[0];
    int bitcount;
    Or[]ors=new Or[0];
    int orcount;
    And[]ands=new And[0];
    int andcount;
    Xor[]xors=new Xor[0];
    int xorcount;
    Nand[]nands=new Nand[0];
    int nandcount;
    Conn[]cons=new Conn[0];
    int concount;
    Inv[]invs=new Inv[0];
    int invcount;
    boolean[]viewin=new boolean[0];
    boolean[]viewout=new boolean[0];
    public Module(String name){
        this.name=name;
    }
    public void printBits(JTextArea result){
        for(int i=0;i<bitcount;i++){
            Bit bitx=bits[i];
            result.append("("+bitx.inname+","+bitx.readname+","+bitx.setname+","+bitx.outname+":"+bitx.value+")\n");
        }
    }
    public void setfalse(){
        visited=new boolean[incount];
        outvisited=new boolean[outcount];
        for(int i=0;i<modulescount;i++){
            modules[i].setfalse();
        }
        for(int i=0;i<constantcount;i++){
            constants[i].setfalse();
        }
        for(int i=0;i<placount;i++){
            plas[i].setfalse();
        }
        for(int i=0;i<bitcount;i++){
            bits[i].setfalse();
        }
        for(int i=0;i<orcount;i++){
            ors[i].setfalse();
        }
        for(int i=0;i<andcount;i++){
            ands[i].setfalse();
        }
        for(int i=0;i<xorcount;i++){
            xors[i].setfalse();
        }
        for(int i=0;i<nandcount;i++){
            nands[i].setfalse();
        }
        for(int i=0;i<invcount;i++){
            invs[i].setfalse();
        }
    }
    public void setviewfalse(){
        viewin=new boolean[incount];
        viewout=new boolean[outcount];
        for(int i=0;i<modulescount;i++){
            modules[i].setviewfalse();
        }
        for(int i=0;i<constantcount;i++){
            constants[i].view=false;
        }
        for(int i=0;i<placount;i++){
            plas[i].view=false;
        }
        for(int i=0;i<bitcount;i++){
            bits[i].view=false;
        }
        for(int i=0;i<orcount;i++){
            ors[i].view=false;
        }
        for(int i=0;i<andcount;i++){
            ands[i].view=false;
        }
        for(int i=0;i<xorcount;i++){
            xors[i].view=false;
        }
        for(int i=0;i<nandcount;i++){
            nands[i].view=false;
        }
        for(int i=0;i<invcount;i++){
            invs[i].view=false;
        }
    }
    public void schalt(){
        if(cycles!=0){
            curcycle++;
            if(curcycle==cycles){
                curcycle=0;
                for(int i=0;i<outcount;i++){
                    out[i]=nextout[i];
                }
            }
        }
    }
    public static int restnumbers(String str){
        int n=str.length();
        boolean ok=true;
        int c=0;
        for(int i=n-1;i>=0;i--){
            String subs=str.substring(i,i+1);
            if(ok&&isnumber(subs)){
                c++;
            }
            if(ok&&!isnumber(subs)){
                ok=false;
            }
        }
        return c;
    }
    public static boolean isnumber(String str){
        if(str.equals("0"))return true;
        if(str.equals("1"))return true;
        if(str.equals("2"))return true;
        if(str.equals("3"))return true;
        if(str.equals("4"))return true;
        if(str.equals("5"))return true;
        if(str.equals("6"))return true;
        if(str.equals("7"))return true;
        if(str.equals("8"))return true;
        if(str.equals("9"))return true;
        return false;
    }
    public String getType(String name){
        for(int i=0;i<incount;i++){
            if(name.equals(inname[i]))return "INNAME";
        }
        for(int i=0;i<outcount;i++){
            if(name.equals(outname[i]))return "OUTNAME";
        }
        for(int i=0;i<constantcount;i++){
            if(name.equals(constants[i].outname))return "CONSTANT";
        }
        for(int i=0;i<bitcount;i++){
            if(name.equals(bits[i].inname))return "BIT";
            if(name.equals(bits[i].outname))return "BIT";
            if(name.equals(bits[i].readname))return "BIT";
            if(name.equals(bits[i].setname))return "BIT";
        }
        for(int i=0;i<invcount;i++){
            if(name.equals(invs[i].inname))return "INV";
            if(name.equals(invs[i].outname))return "INV";
        }
        for(int i=0;i<orcount;i++){
            if(name.equals(ors[i].in1name))return "OR";
            if(name.equals(ors[i].in2name))return "OR";
            if(name.equals(ors[i].outname))return "OR";
        }
        for(int i=0;i<andcount;i++){
            if(name.equals(ands[i].in1name))return "AND";
            if(name.equals(ands[i].in2name))return "AND";
            if(name.equals(ands[i].outname))return "AND";
        }
        for(int i=0;i<xorcount;i++){
            if(name.equals(xors[i].in1name))return "XOR";
            if(name.equals(xors[i].in2name))return "XOR";
            if(name.equals(xors[i].outname))return "XOR";
        }
        for(int i=0;i<nandcount;i++){
            if(name.equals(nands[i].in1name))return "NAND";
            if(name.equals(nands[i].in2name))return "NAND";
            if(name.equals(nands[i].outname))return "NAND";
        }
        int r=restnumbers(name);
        String name2=name.substring(0,name.length()-r);
        for(int i=0;i<placount;i++){
            if(name2.equals(plas[i].name))return "PLA";
        }
        return "NOTFOUND";
    }
    public void addInname(String s){
        int n=inname.length;
        String[]s2=new String[n+1];
        for(int i=0;i<n;i++){
            s2[i]=inname[i];
        }
        s2[n]=s;
        inname=s2;
        incount++;
        in=new int[incount];
        visited=new boolean[incount];
        viewin=new boolean[incount];
    }
    public void addOutname(String s){
        int n=outname.length;
        String[]s2=new String[n+1];
        for(int i=0;i<n;i++){
            s2[i]=outname[i];
        }
        s2[n]=s;
        outname=s2;
        outcount++;
        out=new int[outcount];
        nextout=new int[outcount];
        outvisited=new boolean[outcount];
        viewout=new boolean[outcount];
    }
    public void addModule(Module s){
        int n=modules.length;
        Module[]s2=new Module[n+1];
        for(int i=0;i<n;i++){
            s2[i]=modules[i];
        }
        s2[n]=s;
        modules=s2;
        modulescount++;
    }
    public void addPLA(PLA s){
        int n=plas.length;
        PLA[]s2=new PLA[n+1];
        for(int i=0;i<n;i++){
            s2[i]=plas[i];
        }
        s2[n]=s;
        plas=s2;
        placount++;
    }
    public void addConstant(Constant s){
        int n=constants.length;
        Constant[]s2=new Constant[n+1];
        for(int i=0;i<n;i++){
            s2[i]=constants[i];
        }
        s2[n]=s;
        constants=s2;
        constantcount++;
    }
    public void addBit(Bit s){
        int n=bits.length;
        Bit[]s2=new Bit[n+1];
        for(int i=0;i<n;i++){
            s2[i]=bits[i];
        }
        s2[n]=s;
        bits=s2;
        bitcount++;
    }
    public void addOr(Or s){
        int n=ors.length;
        Or[]s2=new Or[n+1];
        for(int i=0;i<n;i++){
            s2[i]=ors[i];
        }
        s2[n]=s;
        ors=s2;
        orcount++;
    }
    public void addAnd(And s){
        int n=ands.length;
        And[]s2=new And[n+1];
        for(int i=0;i<n;i++){
            s2[i]=ands[i];
        }
        s2[n]=s;
        ands=s2;
        andcount++;
    }
    public void addXor(Xor s){
        int n=xors.length;
        Xor[]s2=new Xor[n+1];
        for(int i=0;i<n;i++){
            s2[i]=xors[i];
        }
        s2[n]=s;
        xors=s2;
        xorcount++;
    }
    public void addNand(Nand s){
        int n=nands.length;
        Nand[]s2=new Nand[n+1];
        for(int i=0;i<n;i++){
            s2[i]=nands[i];
        }
        s2[n]=s;
        nands=s2;
        nandcount++;
    }
    public void addInv(Inv s){
        int n=invs.length;
        Inv[]s2=new Inv[n+1];
        for(int i=0;i<n;i++){
            s2[i]=invs[i];
        }
        s2[n]=s;
        invs=s2;
        invcount++;
    }
    public void addCon(Conn s){
        int n=cons.length;
        Conn[]s2=new Conn[n+1];
        boolean inserted=false;
        for(int i=0;i<n+1;i++){
            if(!inserted&&i<n&&s.left.compareTo(cons[i].left)>=0){
                s2[i]=cons[i];
            }
            else if(!inserted&&i<n&&s.left.compareTo(cons[i].left)<0){
                s2[i]=s;
                inserted=true;
            }
            else if(inserted&&i<n){
                s2[i]=cons[i-1];
            }
            else if(!inserted&&i==n){
                s2[i]=s;
            }
            else if(inserted&&i==n){
                s2[i]=cons[i-1];
            }
        }
        cons=s2;
//for(int i=0;i<concount;i++){
//System.out.println("CONNECT "+cons[i].left+" "+cons[i].right+";");
//}
//System.out.println("");
        concount++;
    }
    public void view(JTextArea result,String path){
        for(int i=0;i<inname.length;i++){
            if(viewin[i]){
                result.append("IN "+inname[i]+": "+in[i]+" path: "+path+"\n");
            }
        }
        for(int i=0;i<ands.length;i++){
            if(ands[i].view){
                ands[i].view(result,path);
            }
        }
        for(int i=0;i<ors.length;i++){
            if(ors[i].view){
                ors[i].view(result,path);
            }
        }
        for(int i=0;i<xors.length;i++){
            if(xors[i].view){
                xors[i].view(result,path);
            }
        }
        for(int i=0;i<nands.length;i++){
            if(nands[i].view){
                nands[i].view(result,path);
            }
        }
        for(int i=0;i<constants.length;i++){
            if(constants[i].view){
                constants[i].view(result,path);
            }
        }
        for(int i=0;i<invs.length;i++){
            if(invs[i].view){
                invs[i].view(result,path);
            }
        }
        for(int i=0;i<bits.length;i++){
            if(bits[i].view){
                bits[i].view(result,path);
            }
        }
        for(int i=0;i<plas.length;i++){
            if(plas[i].view){
                plas[i].view(result,path);
            }
        }
        for(int i=0;i<outname.length;i++){
            if(viewout[i]){
                result.append("OUT "+outname[i]+": "+out[i]+" path: "+path+"\n");
            }
        }
        for(int i=0;i<modules.length;i++){
            modules[i].view(result,path+"."+modules[i].name);
        }
    }
    public void save(PrintStream ps,String path){
//System.out.println("path: "+path);
        for(int i=0;i<inname.length;i++){
            if(viewin[i]){
                ps.println(path+"\n"+inname[i]);
            }
        }
        for(int i=0;i<ands.length;i++){
            if(ands[i].view){
                ps.println(path+"\n"+ands[i].in1name);
            }
        }
        for(int i=0;i<ors.length;i++){
            if(ors[i].view){
                ps.println(path+"\n"+ors[i].in1name);
            }
        }
        for(int i=0;i<xors.length;i++){
            if(xors[i].view){
                ps.println(path+"\n"+xors[i].in1name);
            }
        }
        for(int i=0;i<nands.length;i++){
            if(nands[i].view){
                ps.println(path+"\n"+nands[i].in1name);
            }
        }
        for(int i=0;i<constants.length;i++){
            if(constants[i].view){
                ps.println(path+"\n"+constants[i].outname);
            }
        }
        for(int i=0;i<invs.length;i++){
            if(invs[i].view){
                ps.println(path+"\n"+invs[i].inname);
            }
        }
        for(int i=0;i<bits.length;i++){
            if(bits[i].view){
                ps.println(path+"\n"+bits[i].inname);
            }
        }
        for(int i=0;i<plas.length;i++){
            if(plas[i].view){
                ps.println(path+"\n"+plas[i].name);
            }
        }
        for(int i=0;i<outname.length;i++){
            if(viewout[i]){
                ps.println(path+"\n"+outname[i]);
            }
        }
        for(int i=0;i<modules.length;i++){
            modules[i].save(ps,path+"."+modules[i].name);
        }
    }
    public void load(JTextArea result,String gpath,String path,String keyword){
        if("".equals(path)){
            setview(result,keyword,gpath);
        }
        else{
            int ind=path.indexOf(".");
            String next="";
            String cur=path;
            if(ind!=-1){
                next=path.substring(ind+1);
                cur=path.substring(0,ind);
            }
            boolean found=false;
            for(int i=0;i<modules.length;i++){
                if(modules[i].name.equals(cur)){
                    modules[i].load(result,gpath,next,keyword);
                    found=true;
                }
            }
            if(!found){
                result.append("signal not found: "+gpath+" MODULE not found: "+path+"\n");
            }
        }
    }
    public void setview(JTextArea result,String keyword,String gpath){
        boolean found=false;
        for(int i=0;i<inname.length;i++){
            if(inname[i].equals(keyword)){
                viewin[i]=true;
                found=true;
            }
        }
        for(int i=0;i<ands.length;i++){
            if(ands[i].in1name.equals(keyword)){
                ands[i].view=true;
                found=true;
            }
        }
        for(int i=0;i<ors.length;i++){
            if(ors[i].in1name.equals(keyword)){
                ors[i].view=true;
                found=true;
            }
        }
        for(int i=0;i<xors.length;i++){
            if(xors[i].in1name.equals(keyword)){
                xors[i].view=true;
                found=true;
            }
        }
        for(int i=0;i<nands.length;i++){
            if(nands[i].in1name.equals(keyword)){
                nands[i].view=true;
                found=true;
            }
        }
        for(int i=0;i<constants.length;i++){
            if(constants[i].outname.equals(keyword)){
                constants[i].view=true;
                found=true;
            }
        }
        for(int i=0;i<invs.length;i++){
            if(invs[i].inname.equals(keyword)){
                invs[i].view=true;
                found=true;
            }
        }
        for(int i=0;i<bits.length;i++){
            if(bits[i].inname.equals(keyword)){
                bits[i].view=true;
                found=true;
            }
        }
        for(int i=0;i<plas.length;i++){
            if(plas[i].name.equals(keyword)){
                plas[i].view=true;
                found=true;
            }
        }
        for(int i=0;i<outname.length;i++){
            if(outname[i].equals(keyword)){
                viewout[i]=true;
                found=true;
            }
        }
        if(!found){
            result.append("not found: "+keyword+" path: "+gpath+"\n");
        }
    }
}
class AllModules{
    Module[]modules=new Module[0];
    Constant[]constants=new Constant[0];
    public void add(Module m){
        int n=modules.length;
        Module[]m2=new Module[n+1];
        for(int i=0;i<n;i++){
            m2[i]=modules[i];
        }
        m2[n]=m;
        modules=m2;
    }
    public void addConstant(Constant m){
        int n=constants.length;
        Constant[]m2=new Constant[n+1];
        for(int i=0;i<n;i++){
            m2[i]=constants[i];
        }
        m2[n]=m;
        constants=m2;
    }
    public void schalt(){
        for(int i=0;i<modules.length;i++){
            modules[i].schalt();
        }
    }
}
class Holder{
    Module module;
    PLA pla;
    Bit bit;
    Or or;
    And and;
    Xor xor;
    Nand nand;
    Constant constant;
    Inv inv;
    String type;
    String inout;
    Holder next;
    Holder fore;
    public Holder(Module module,String inout){
        this.module=module;
        this.inout=inout;
        type="MODULE";
    }
    public boolean visited(){
        if(type.equals("PLA")){
            return pla.visited;
        }
        if(type.equals("BIT")){
            return bit.visited;
        }
        if(type.equals("AND")){
            return and.visited;
        }
        if(type.equals("OR")){
            return or.visited;
        }
        if(type.equals("XOR")){
            return xor.visited;
        }
        if(type.equals("NAND")){
            return nand.visited;
        }
        if(type.equals("INV")){
            return inv.visited;
        }
        if(type.equals("CONSTANT")){
            return constant.visited;
        }
        return false;
    }
    public Holder(PLA pla){
        this.pla=pla;
        type="PLA";
    }
    public Holder(Bit bit){
        this.bit=bit;
        type="BIT";
    }
    public Holder(Or or){
        this.or=or;
        type="OR";
    }
    public Holder(And and){
        this.and=and;
        type="AND";
    }
    public Holder(Xor xor){
        this.xor=xor;
        type="XOR";
    }
    public Holder(Nand nand){
        this.nand=nand;
        type="NAND";
    }
    public Holder(Constant constant){
        this.constant=constant;
        type="CONSTANT";
    }
    public Holder(Inv inv){
        this.inv=inv;
        type="INV";
    }
}
class Curver{
    Holder base;
    Holder top;
    JTextArea result;
    Stopper stopper;
    AstroChip asch;
boolean disp;
boolean notreached=true;
    public Curver(AstroChip asch,JTextArea result,Stopper stopper){
        this.asch=asch;
        this.result=result;
        this.stopper=stopper;
    }
    public boolean isNotEmpty(){
        return (base!=null);
    }
    public void drawQueue(){
        if(base==null)return;
        Holder h=base;
        int c=0;
        while(h!=top){
            result.append("c:"+c+":"+h.type+":"+h.visited());
            c++;
            h=h.next;
        }
        result.append("c:"+c+":"+h.type+":"+h.visited());
        result.append("\n");
    }
    public void countQueue(){
//System.out.println("disp: "+disp);
if(!disp)return;
        int c=0;
        Holder h=base;
        while(h!=null&&h!=top){
//System.out.println("type: "+h.type);
if("MODULE".equals(h.type)){
//System.out.println("name: "+h.module.name);
}
if("OR".equals(h.type)){
//System.out.println("name: "+h.or.in1name);
}
if("AND".equals(h.type)){
//System.out.println("name: "+h.and.in1name);
}
            c=c+1;
            h=h.next;
        }
        asch.setTitle("elements to process: "+c);
//        System.out.println("c: "+c);
//if(false&&c!=76)try{Thread.sleep(2000);}catch(Exception e){};
        if(true&&c==9){

try{
Thread.sleep(1000);
}
catch(Exception e){
}

        h=base;
        while(h!=null&&h!=top){
try{
Thread.sleep(50);
}
catch(Exception e){
}
System.out.println("type: "+h.type);
if("AND".equals(h.type)){
System.out.println("in1name: "+h.and.in1name+" "+h.and.in1visited);
System.out.println("in2name: "+h.and.in2name+" "+h.and.in2visited);
}
if("OR".equals(h.type)){
System.out.println("in1name: "+h.or.in1name+" "+h.or.in1visited);
System.out.println("in2name: "+h.or.in2name+" "+h.or.in2visited);
}
if("MODULE".equals(h.type)){
System.out.println("name: "+h.module.name);
System.out.println("parent: "+h.module.parent.name);
if("asbbusin".equals(h.module.name)){
for(int i=0;i<h.module.visited.length;i++){
System.out.println("i:"+i+"bol:"+h.module.visited[i]);
}
for(int i=0;i<h.module.outvisited.length;i++){
System.out.println("out i:"+i+"bol:"+h.module.outvisited[i]);
}
try{
Thread.sleep(1000);
}
catch(Exception e){
}
}
boolean somevisited=false;
for(int i=0;i<h.module.outvisited.length;i++){
if(h.module.outvisited[i]){
somevisited=true;
}
//System.out.println("out i:"+i+"bol:"+h.module.outvisited[i]);
}
if(somevisited){
//System.out.println("name: "+h.module.name);
for(int i=0;i<h.module.outvisited.length;i++){
System.out.println("i:"+i+"bol:"+h.module.outvisited[i]);
}
//try{Thread.sleep(1000);}catch(Exception e){};
}
}
if("AND".equals(h.type)){
if((h.and.in1visited||h.and.in1visited)&&!(h.and.in1visited&&h.and.in2visited)){
System.out.println("name: "+h.and.in1name+" : "+h.and.in2name);
}
}
if("OR".equals(h.type)){
if((h.or.in1visited||h.or.in1visited)&&!(h.or.in1visited&&h.or.in2visited)){
System.out.println("name: "+h.or.in1name+" : "+h.or.in2name);
}
}
            h=h.next;
        }
        }
    }
    public void delvisited(){
        if(base==null)return;
        Holder h=base;
        while(h!=top){
            if(h.visited()){
                if(h==base&&base!=top){
                    base=base.next;
                }
                else{
                    Holder h2=h.fore;
                    Holder h3=h.next;
                    h2.next=h3;
                    h3.fore=h2;
                }
            }
            h=h.next;
        }
        if(top.visited()){
            if(base==top){
                base=null;
                top=null;
            }
            else{
                top=top.fore;
            }
        }
//drawQueue();
    }
    public void addElemTop(Holder h){
        if(base==null){
            top=h;
            base=h;
        }
        else{
            top.next=h;
            h.fore=top;
            top=top.next;
        }
    }
    public void addElemBase(Holder h){
        if(base==null){
            top=h;
            base=h;
        }
        else{
            base.fore=h;
            h.next=base;
            base=base.fore;
        }
    }
    public void processtarget(Module module,Conn con,int value){
        if(con.targettype.equals("NOTFOUND")){
            result.append("runtime error, CONNECTION from "+con.left+" to "+con.right+" in MODULE "+module.name+" not found\n");
        }
        else if(con.targettype.equals("OR")){
            Or[]ors=module.ors;
            for(int i=0;i<ors.length;i++){
                boolean wasvisited=ors[i].in1visited||ors[i].in2visited;
                if(con.right.equals(ors[i].in1name)){
                    ors[i].in1=value;
                    ors[i].in1visited=true;
                }
                if(con.right.equals(ors[i].in2name)){
                    ors[i].in2=value;
                    ors[i].in2visited=true;
                }
                if(con.right.equals(ors[i].in2name)||con.right.equals(ors[i].in1name)){
                    Holder h=new Holder(ors[i]);
                    if(!wasvisited){
                        addElemBase(h);
                    }
                }
            }
        }
        else if(con.targettype.equals("AND")){
            And[]ands=module.ands;
            for(int i=0;i<ands.length;i++){
                boolean wasvisited2=ands[i].in1visited||ands[i].in2visited;
                if(con.right.equals(ands[i].in1name)){
                    ands[i].in1=value;
                    ands[i].in1visited=true;
                }
                if(con.right.equals(ands[i].in2name)){
                    ands[i].in2=value;
                    ands[i].in2visited=true;
                }
                if(con.right.equals(ands[i].in2name)||con.right.equals(ands[i].in1name)){
                    Holder h=new Holder(ands[i]);
                    if(!wasvisited2){
                        addElemBase(h);
                    }
                }
            }
        }
        else if(con.targettype.equals("XOR")){
            Xor[]xors=module.xors;
            for(int i=0;i<xors.length;i++){
                boolean wasvisited3=xors[i].in1visited||xors[i].in2visited;
                if(con.right.equals(xors[i].in1name)){
                    xors[i].in1=value;
                    xors[i].in1visited=true;
                }
                if(con.right.equals(xors[i].in2name)){
                    xors[i].in2=value;
                    xors[i].in2visited=true;
                }
                if(con.right.equals(xors[i].in2name)||con.right.equals(xors[i].in1name)){
                    Holder h=new Holder(xors[i]);
                    if(!wasvisited3){
                        addElemBase(h);
                    }
                }
            }
        }
        else if(con.targettype.equals("NAND")){
            Nand[]nands=module.nands;
            for(int i=0;i<nands.length;i++){
                boolean wasvisited4=nands[i].in1visited||nands[i].in2visited;
                if(con.right.equals(nands[i].in1name)){
                    nands[i].in1=value;
                    nands[i].in1visited=true;
                }
                if(con.right.equals(nands[i].in2name)){
                    nands[i].in2=value;
                    nands[i].in2visited=true;
                }
                if(con.right.equals(nands[i].in2name)||con.right.equals(nands[i].in1name)){
                    Holder h=new Holder(nands[i]);
                    if(!wasvisited4){
                        addElemBase(h);
                    }
                }
            }
        }
        else if(con.targettype.equals("INV")){
            Inv[]invs=module.invs;
            for(int i=0;i<invs.length;i++){
                boolean wasvisited5=invs[i].invisited;
                if(con.right.equals(invs[i].inname)){
                    invs[i].in=value;
                    invs[i].invisited=true;
                    Holder h=new Holder(invs[i]);
                    if(!wasvisited5){
                        addElemBase(h);
                    }
                }
            }
        }
        else if(con.targettype.equals("PLA")){
            PLA[]plas=module.plas;
            String rs=con.right;
            int n=rs.length();
            int r=Module.restnumbers(rs);
            String concrete=rs.substring(0,n-r);
            int num=new Integer(rs.substring(n-r,n)).intValue();
            for(int i=0;i<plas.length;i++){
                if(concrete.equals(plas[i].name)){
                    plas[i].in[num]=value;
                    plas[i].invisited[num]=true;
                    Holder h=new Holder(plas[i]);
                    boolean wasvisited6=false;
//                    for(int j=0;j<plas[i].incount;j++){
//                        if(plas[i].invisited[j])wasvisited6=true;
//                    }
//                    if(!wasvisited6){
                        addElemBase(h);
//                    }
                }
            }
        }
        else if(con.targettype.equals("OUTNAME")){
            String outs=con.right;
            String[]outs2=module.outname;
            for(int i=0;i<outs2.length;i++){
                if(outs.equals(outs2[i])){
                    module.nextout[i]=value;
                    module.outvisited[i]=true;
                }
            }
            boolean oko=true;
            for(int i=0;i<outs2.length;i++){
                if(!module.outvisited[i]){
                    oko=false;
                }
            }
            if(module.cycles==0&&oko){
                Holder h2=new Holder(module,"OUT");
                addElemBase(h2);
            }
//            top=top.fore;
        }
        else if(con.targettype.equals("MODULE")){
            String rsx=con.right;
            int ind=rsx.indexOf(".");
            String modulestring=rsx.substring(0,ind);
            String namestring=rsx.substring(ind+1);
            for(int i=0;i<module.modulescount;i++){
                if(module.modules[i].name.equals(modulestring)){
//System.out.println("XMODULE "+modulestring+" : "+rsx);
//try{
//Thread.sleep(1000);
//}
//catch(Exception h){
//}
                    Module m=module.modules[i];
                    boolean mb=false;
                    boolean wasvisited7=false;
                    for(int j=0;j<m.incount;j++){
                        if(m.inname[j].equals(namestring)){
                            for(int k=0;k<m.incount;k++){
                                if(m.visited[k])wasvisited7=true;
                            }
                            for(int k=0;k<m.incount;k++){
//                                System.out.println("invisited: "+k+" "+m.visited[k]);
                            }
                            m.in[j]=value;
                            m.visited[j]=true;
                            mb=true;
                        }
                    }
                    if(mb&&!wasvisited7){
                        Holder h=new Holder(m,"IN");
                        addElemBase(h);
                    }
                }
            }
        }
        else if(con.targettype.equals("BIT")){
            Bit[]bits=module.bits;
            for(int i=0;i<bits.length;i++){
                boolean wasvisited8=bits[i].invisited||bits[i].readvisited||bits[i].setvisited;
                if(con.right.equals(bits[i].inname)){
                    bits[i].in=value;
                    bits[i].invisited=true;
                }
                if(con.right.equals(bits[i].readname)){
                    bits[i].read=value;
                    bits[i].readvisited=true;
                }
                if(con.right.equals(bits[i].setname)){
                    bits[i].set=value;
                    bits[i].setvisited=true;
                }
                if(con.right.equals(bits[i].inname)||con.right.equals(bits[i].readname)||con.right.equals(bits[i].setname)){
                    Holder h=new Holder(bits[i]);
                    if(!wasvisited8){
                        addElemBase(h);
                    }
                }
            }
        }
    }
    public void process(){
        countQueue();
        Holder h=top;
if(h.module!=null){
//System.out.println("xxx2: "+h.module.name);
//System.out.println("xxx3: "+h.inout);
}
        Module parent=null;
        Conn[]cons=null;
        if(h.type.equals("MODULE")&&h.inout.equals("OUT")){
            boolean okn=true;
            if(h.module.cycles==0){
                for(int i=0;i<h.module.outcount;i++){
                    if(!h.module.outvisited[i]){
//                        System.out.println("false: "+h.module.name+" "+h.module.outname[i]);
                        okn=false;
                    }
                }
            }
            if(!okn&&h.module.cycles==0){
//System.out.println("okn1: "+okn);
                addElemBase(h);
                top=top.fore;
            }
            else{
                if(h.module.cycles==0){
                    for(int i=0;i<h.module.out.length;i++){
                        h.module.out[i]=h.module.nextout[i];
                    }
                }
//System.out.println("okn2: "+okn);
                String sn=h.module.name;
                String[]outname=h.module.outname;
                int[]out=h.module.out;
                parent=h.module;
                if(parent.parent!=null){
                    for(int i=0;i<outname.length;i++){
                        String left=sn+"."+outname[i];
                        cons=parent.parent.cons;
                        TwoPoint tp=Curver.findBegin(cons,left);
                        for(int j=tp.a;j<tp.b;j++){
//                            if(left.equals(cons[j].left)){
                                processtarget(parent.parent,cons[j],out[i]);
//                            }
                        }

                    }
                }
                if(top==base){
                    top=null;
                    base=null;
                }
                else{
                    top=top.fore;
                }
            }
        }
        else if(h.type.equals("MODULE")&&h.inout.equals("IN")){
            parent=h.module;
            boolean oki=true;
            for(int i=0;i<parent.incount;i++){
//System.out.println("PART oki: "+parent.visited[i]+" "+parent.name);
                if(!parent.visited[i])oki=false;
            }
//System.out.println("IN oki: "+oki+" "+parent.name);
            if(oki){
                String[]inname=parent.inname;
                cons=parent.cons;
                for(int i=0;i<inname.length;i++){
                    TwoPoint tp=Curver.findBegin(cons,inname[i]);
                    for(int j=tp.a;j<tp.b;j++){
//                        if(inname[i].equals(cons[j].left)){
//System.out.println("right oki "+cons[j].targettype+" : "+cons[j].right+" : "+cons[j].left);
                            processtarget(parent,cons[j],parent.in[i]);
//System.out.println("processed");
//                        }
                    }
                }
                top=top.fore;
            }
            else{
                addElemBase(h);
                top=top.fore;
            }
        }
        else if(h.type.equals("CONSTANT")){
            parent=h.constant.parent;
            String outnam=h.constant.outname;
            cons=parent.cons;
            TwoPoint tp=Curver.findBegin(cons,outnam);
            for(int i=tp.a;i<tp.b;i++){
//                if(outnam.equals(cons[i].left)){
                    processtarget(parent,cons[i],h.constant.value);
//                }
            }
            h.constant.visited=true;
            top=top.fore;
        }
        else if(h.type.equals("OR")){
            Or or=h.or;
            if(or.in1visited&&or.in2visited){
                if(or.in1==1||or.in2==1){
                    or.out=1;
                }
                else{
                    or.out=0;
                }
                parent=or.parent;
                cons=parent.cons;
                TwoPoint tp=Curver.findBegin(cons,or.outname);
                for(int i=tp.a;i<tp.b;i++){
//                    if(or.outname.equals(cons[i].left)){
                        processtarget(parent,cons[i],or.out);
//                    }
                }
                or.visited=true;
                top=top.fore;
            }
            else{
                addElemBase(h);
                top=top.fore;
            }
        }
        else if(h.type.equals("AND")){
            And and=h.and;
//System.out.println("parent: "+and.parent.name+" a "+and.in1visited+" b "+and.in2visited);
//try{
//Thread.sleep(4000);
//}
//catch(Exception e99){
//}
            if(and.in1visited&&and.in2visited){
                if(and.in1==1&&and.in2==1){
                    and.out=1;
                }
                else{
                    and.out=0;
                }
                parent=and.parent;
                cons=parent.cons;
                TwoPoint tp=Curver.findBegin(cons,and.outname);
                for(int i=tp.a;i<tp.b;i++){
//                    if(and.outname.equals(cons[i].left)){
//System.out.println("astroand "+cons[i].right);
//try{
//Thread.sleep(4000);
//}
//catch(Exception e99){
//}
                        processtarget(parent,cons[i],and.out);
//                    }
                }
                and.visited=true;
                top=top.fore;
            }
            else{
                addElemBase(h);
                top=top.fore;
            }
        }
        else if(h.type.equals("XOR")){
            Xor xor=h.xor;
            if(xor.in1visited&&xor.in2visited){
                if((xor.in1==1&&xor.in2==0)||(xor.in1==0&&xor.in2==1)){
                    xor.out=1;
                }
                else{
                    xor.out=0;
                }
                parent=xor.parent;
                cons=parent.cons;
                TwoPoint tp=Curver.findBegin(cons,xor.outname);
                for(int i=tp.a;i<tp.b;i++){
//                    if(xor.outname.equals(cons[i].left)){
                        processtarget(parent,cons[i],xor.out);
//                    }
                }
                xor.visited=true;
                top=top.fore;
            }
            else{
                addElemBase(h);
                top=top.fore;
            }
        }
        else if(h.type.equals("NAND")){
            Nand nand=h.nand;
            if(nand.in1visited&&nand.in2visited){
                if(!(nand.in1==1&&nand.in2==1)){
                    nand.out=1;
                }
                else{
                    nand.out=0;
                }
                parent=nand.parent;
                cons=parent.cons;
                TwoPoint tp=Curver.findBegin(cons,nand.outname);
                for(int i=tp.a;i<tp.b;i++){
//                    if(nand.outname.equals(cons[i].left)){
                        processtarget(parent,cons[i],nand.out);
//                    }
                }
                nand.visited=true;
                top=top.fore;
            }
            else{
                addElemBase(h);
                top=top.fore;
            }
        }
        else if(h.type.equals("INV")){
            Inv inv=h.inv;
            if(inv.invisited){
                if(inv.in==0){
                    inv.out=1;
                }
                else{
                    inv.out=0;
                }
                parent=inv.parent;
                cons=parent.cons;
                TwoPoint tp=Curver.findBegin(cons,inv.outname);
                for(int i=tp.a;i<tp.b;i++){
//                    if(inv.outname.equals(cons[i].left)){
                        processtarget(parent,cons[i],inv.out);
//                    }
                }
                inv.visited=true;
                top=top.fore;
            }
            else{
                addElemBase(h);
                top=top.fore;
            }
        }
        else if(h.type.equals("PLA")){
            PLA pla=h.pla;
            boolean okv=true;
            for(int i=0;i<pla.incount;i++){
//System.out.println("plain "+i+" "+pla.invisited[i]);
                if(!pla.invisited[i]){
                    okv=false;
                }
            }
            if(okv){
                pla.getResult();
                String plana=pla.name;
                parent=pla.parent;
                cons=parent.cons;
                for(int i=0;i<pla.outcount;i++){
                    String outna=plana+i;
                    int curout=pla.out[i];
//System.out.println("outna: "+outna);
                    TwoPoint tp=Curver.findBegin(cons,outna);
//System.out.println("tp.b "+tp.b);
                    for(int j=tp.a;j<tp.b;j++){
//System.out.println("PLA j: "+j+" "+outna);
                        if(outna.equals(cons[j].left)){
                            processtarget(parent,cons[j],curout);
                        }
                    }
                }
                pla.visited=true;
                top=top.fore;
            }
            else{
                addElemBase(h);
                top=top.fore;
            }
        }
        else if(h.type.equals("BIT")){
            Bit bit=h.bit;
            if(bit.invisited&&bit.readvisited&&bit.setvisited){
                if(bit.set==1){
                    bit.value=bit.in;
                }
                if(bit.read==1){
                    bit.out=bit.value;
                }
                parent=bit.parent;
                cons=parent.cons;
                TwoPoint tp=Curver.findBegin(cons,bit.outname);
                for(int i=tp.a;i<tp.b;i++){
//                    if(bit.outname.equals(cons[i].left)){
                        processtarget(parent,cons[i],bit.out);
//                    }
                }
                bit.visited=true;
                top=top.fore;
            }
            else{
                addElemBase(h);
                top=top.fore;
            }
        }
        if(top==null)base=null;
    }
    public static TwoPoint findBegin(Conn[]cons,String s){
        int n=cons.length;
        if(n==0){
            return new TwoPoint(0,-1);
        }
        int m=(n-1)/2;
        int l=0;
        int r=n-1;
        boolean running=true;
        int am=m;
        int al=l;
        int ar=r;
        while(running){
//System.out.println("l: "+l+" r: "+r+" m: "+m+" c: "+cons[m].left);
            if(cons[m].left.compareTo(s)>0){
                r=m;
                m=(r+l)/2;
            }
            else if(cons[m].left.compareTo(s)<0){
                l=m;
                m=(r+l)/2;
            }
            else{
//System.out.println("");
                running=false;
                int a=m;
                while(a>=0&&s.equals(cons[a].left)){
                    a--;
                }
                a++;
                int b=m;
                while(b<n&&s.equals(cons[b].left)){
                    b++;
                }
//System.out.println("a: "+a+" b: "+b+" "+s);
//if(a>0){
//System.out.println("bef: "+cons[a-1].left);
//}
//for(int i=a;i<b;i++){
//System.out.println(cons[i].left);
//}
//if(b<n){
//System.out.println("aft: "+cons[b].left);
//}
//System.out.println("");
                return new TwoPoint(a,b);
            }
            if(am==m&&ar==r&&al==l&&r-l==0){
                return new TwoPoint(0,-1);
            }
            if(am==m&&ar==r&&al==l&&r-l>0){
                m=m+1;
                r=r;
                l=l+1;
            }
            am=m;
            al=l;
            ar=r;
        }
        return new TwoPoint(0,-1);
    }
}
class TwoPoint{
    int a;
    int b;
    public TwoPoint(int a,int b){
        this.a=a;
        this.b=b;
    }
}
class Stopper{
    boolean stop=false;
}
class Conn{
    Module parent;
    String left;
    String right;
    String targettype;
    String sourcetype;
    public Conn(){
    }
}
class ModuleBrowser extends JFrame implements Runnable,ActionListener{
    Module m;
    Module main;
    Vector<String> lcontent;
    JList<String> l;
    JScrollPane spl;
    Vector<String> l2content;
    JList<String> l2;
    JScrollPane spl2;
    Vector<String> l3content;
    JList<String> l3;
    JScrollPane spl3;
    JButton open;
    JButton parent;
    JButton add;
    JButton remove;
    JButton load;
    JButton save;
    JTextArea ta;
    JScrollPane spta;
    boolean openb=false;
    boolean parentb=false;
    boolean addb=false;
    boolean removeb=false;
    boolean loadb=false;
    boolean saveb=false;
    Thread t;
    private static final long serialVersionUID = 1581426258660617299L;
    public ModuleBrowser(Module m,Module main){
        super("Astro Solutions ModuleBrowser");
        pack();
        setSize(640,640);
        setLayout(null);
        this.m=m;
        this.main=main;
        lcontent=new Vector<String>();
        l=new JList<String>(lcontent);
        spl=new JScrollPane(l);
        l2content=new Vector<String>();
        l2=new JList<String>(l2content);
        spl2=new JScrollPane(l2);
        l3content=new Vector<String>();
        l3=new JList<String>(l3content);
        spl3=new JScrollPane(l3);
        open=new JButton("open");
        parent=new JButton("parent");
        add=new JButton("view on");
        remove=new JButton("view off");
        load=new JButton("load");
        save=new JButton("save");
        ta=new JTextArea();
        spta=new JScrollPane(ta);
        add(spl);
        add(spl2);
        add(spl3);
        add(open);
        add(parent);
        add(add);
        add(remove);
        add(load);
        add(save);
        add(spta);
        spl.setBounds(10,40,280,180);
        spl3.setBounds(310,40,180,180);
        open.setBounds(10,230,80,27);
        parent.setBounds(110,230,80,27);
        add.setBounds(210,230,80,27);
        remove.setBounds(310,230,80,27);
        load.setBounds(410,230,80,27);
        save.setBounds(410,260,80,27);
        spl2.setBounds(10,270,380,200);
        spta.setBounds(10,490,380,100);
        setVisible(true);
        open.addActionListener(this);
        parent.addActionListener(this);
        add.addActionListener(this);
        remove.addActionListener(this);
        load.addActionListener(this);
        save.addActionListener(this);
        setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
        t=new Thread(this);
        t.start();
    }
    public void run(){
        loadModules();
        loadAll();
        loadView();
        while(true){
            try{
                if(openb){
                    openb=false;
                    int ind=l3.getSelectedIndex();
                    if(ind!=-1&&ind<l3content.size()){
                        m=m.modules[ind];
                        setTitle("MODULE "+m.name);
                        loadModules();
                        loadAll();
                        loadView();
                    }
                }
                if(parentb){
                    parentb=false;
                    if(m.parent!=null){
                        m=m.parent;
                        setTitle("MODULE "+m.name);
                        loadModules();
                        loadAll();
                        loadView();
                    }
                    else{
                        ta.append("no parent\n");
                    }
                }
                if(addb){
                    addb=false;
                    int ind=l.getSelectedIndex();
                    if(ind!=-1&&ind<lcontent.size()){
                        String s=lcontent.elementAt(ind);
                        setView(s,true);
                    }
                }
                if(removeb){
                    removeb=false;
                    int ind=l2.getSelectedIndex();
                    if(ind!=-1&&ind<l2content.size()){
                        String s=l2content.elementAt(ind);
                        setView(s,false);
                        l2content.removeElementAt(ind);
                        l2.setListData(l2content);
                    }
                }
                if(loadb){
                    loadb=false;
                    JFileChooser fd=new JFileChooser();
                    FileNameExtensionFilter filter=new FileNameExtensionFilter("load: select .view file","view");
                    fd.setFileFilter(filter);
                    int ret=fd.showOpenDialog(this);
                    File filo=null;
                    if(ret==JFileChooser.APPROVE_OPTION){
                        filo=fd.getSelectedFile();
                    }
                    else{
                        ta.append("fileselect load error\n");
                        return;
                    }
                    String fn=filo.getAbsolutePath();
                    if(main!=null){
                        main.setviewfalse();
                        FileInputStream fis=new FileInputStream(fn);
                        BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
                        String inp="";
                        while((inp=dis.readLine())!=null){
                            String inp2=dis.readLine();
                            if(main!=null){
                                inp=inp.substring(5);
                                main.load(ta,inp+"."+inp2,inp,inp2);
                            }
                            else{
                                ta.append("main==null ERROR: not compiled?\n");
                            }
                        }
                        fis.close();
                        ta.append("new view file loaded: old viewflags overwritten\n");
                    }
                }
                if(saveb){
                    saveb=false;
                    JFileChooser fds=new JFileChooser();
                    FileNameExtensionFilter filters=new FileNameExtensionFilter("save: select .view file","view");
                    fds.setFileFilter(filters);
                    int rets=fds.showSaveDialog(null);
                    File f=null;
                    String fn=null;
                    if(rets==JFileChooser.APPROVE_OPTION){
                        f=fds.getSelectedFile();
                        fn=f.getAbsolutePath();
                    }
                    if(fn==null){
                        ta.append("fileselect save error\n");
                        return;
                    }
                    if(fn!=null){
                        FileOutputStream fos=new FileOutputStream(fn);
                        PrintStream ps=new PrintStream(fos);
                        main.save(ps,"main");
                        fos.close();
                        ta.append("view file saved: "+fn+"\n");
                    }
                }
                Thread.sleep(100);
            }
            catch(Exception e){
                e.printStackTrace(System.out);
            }
        }
    }
    public void actionPerformed(ActionEvent evt){
        if(open==evt.getSource()){
            openb=true;
        }
        if(parent==evt.getSource()){
            parentb=true;
        }
        if(add==evt.getSource()){
            addb=true;
        }
        if(remove==evt.getSource()){
            removeb=true;
        }
        if(load==evt.getSource()){
            loadb=true;
        }
        if(save==evt.getSource()){
            saveb=true;
        }
    }
    public void loadModules(){
        l3content=new Vector<String>();
        for(int i=0;i<m.modules.length;i++){
            l3content.addElement(m.modules[i].name);
        }
        l3.setListData(l3content);
    }
    public void setView(String s,boolean res){
        for(int i=0;i<m.inname.length;i++){
            String s2=("IN "+m.inname[i]);
            if(s.equals(s2)){
                m.viewin[i]=res;
            }
        }
        for(int i=0;i<m.ands.length;i++){
            String s2=("AND "+m.ands[i].in1name+" "+m.ands[i].in2name+" "+m.ands[i].outname);
            if(s.equals(s2)){
                m.ands[i].view=res;
            }
        }
        for(int i=0;i<m.ors.length;i++){
            String s2=("OR "+m.ors[i].in1name+" "+m.ors[i].in2name+" "+m.ors[i].outname);
            if(s.equals(s2)){
                m.ors[i].view=res;
            }
        }
        for(int i=0;i<m.xors.length;i++){
            String s2=("XOR "+m.xors[i].in1name+" "+m.xors[i].in2name+" "+m.xors[i].outname);
            if(s.equals(s2)){
                m.xors[i].view=res;
            }
        }
        for(int i=0;i<m.nands.length;i++){
            String s2=("NAND "+m.nands[i].in1name+" "+m.nands[i].in2name+" "+m.nands[i].outname);
            if(s.equals(s2)){
                m.nands[i].view=res;
            }
        }
        for(int i=0;i<m.constants.length;i++){
            String s2=("CONSTANT "+m.constants[i].outname);
            if(s.equals(s2)){
                m.constants[i].view=res;
            }
        }
        for(int i=0;i<m.invs.length;i++){
            String s2=("INV "+m.invs[i].inname+" "+m.invs[i].outname);
            if(s.equals(s2)){
                m.invs[i].view=res;
            }
        }
        for(int i=0;i<m.bits.length;i++){
            String s2=("BIT "+m.bits[i].readname+" "+m.bits[i].setname+" "+m.bits[i].inname+" "+m.bits[i].outname);
            if(s.equals(s2)){
                m.bits[i].view=res;
            }
        }
        for(int i=0;i<m.plas.length;i++){
            String s2=("PLA "+m.plas[i].name);
            if(s.equals(s2)){
                m.plas[i].view=res;
            }
        }
        for(int i=0;i<m.outname.length;i++){
            String s2=("OUT "+m.outname[i]);
            if(s.equals(s2)){
                m.viewout[i]=res;
            }
        }
        if(res){
            int co=l2content.size();
            boolean ncon=true;
            for(int i=0;i<co;i++){
                if(s.equals(l2content.elementAt(i))){
                    ncon=false;
                }
            }
            if(ncon){
                l2content.addElement(s);
            }
            l2.setListData(l2content);
        }
    }
    public void loadView(){
        l2content=new Vector<String>();
        for(int i=0;i<m.inname.length;i++){
            if(m.viewin[i]){
                l2content.addElement("IN "+m.inname[i]);
            }
        }
        for(int i=0;i<m.ands.length;i++){
            if(m.ands[i].view){
                l2content.addElement("AND "+m.ands[i].in1name+" "+m.ands[i].in2name+" "+m.ands[i].outname);
            }
        }
        for(int i=0;i<m.ors.length;i++){
            if(m.ors[i].view){
                l2content.addElement("OR "+m.ors[i].in1name+" "+m.ors[i].in2name+" "+m.ors[i].outname);
            }
        }
        for(int i=0;i<m.xors.length;i++){
            if(m.xors[i].view){
                l2content.addElement("XOR "+m.xors[i].in1name+" "+m.xors[i].in2name+" "+m.xors[i].outname);
            }
        }
        for(int i=0;i<m.nands.length;i++){
            if(m.nands[i].view){
                l2content.addElement("NAND "+m.nands[i].in1name+" "+m.nands[i].in2name+" "+m.nands[i].outname);
            }
        }
        for(int i=0;i<m.constants.length;i++){
            if(m.constants[i].view){
                l2content.addElement("CONSTANT "+m.constants[i].outname);
            }
        }
        for(int i=0;i<m.invs.length;i++){
            if(m.invs[i].view){
                l2content.addElement("INV "+m.invs[i].inname+" "+m.invs[i].outname);
            }
        }
        for(int i=0;i<m.bits.length;i++){
            if(m.bits[i].view){
                l2content.addElement("BIT "+m.bits[i].readname+" "+m.bits[i].setname+" "+m.bits[i].inname+" "+m.bits[i].outname);
            }
        }
        for(int i=0;i<m.plas.length;i++){
            if(m.plas[i].view){
                l2content.addElement("PLA "+m.plas[i].name);
            }
        }
        for(int i=0;i<m.outname.length;i++){
            if(m.viewout[i]){
                l2content.addElement("OUT "+m.outname[i]);
            }
        }
        l2.setListData(l2content);
    }
    public void loadAll(){
        lcontent=new Vector<String>();
        for(int i=0;i<m.inname.length;i++){
            if(true){
                lcontent.addElement("IN "+m.inname[i]);
            }
        }
        for(int i=0;i<m.ands.length;i++){
            if(true){
                lcontent.addElement("AND "+m.ands[i].in1name+" "+m.ands[i].in2name+" "+m.ands[i].outname);
            }
        }
        for(int i=0;i<m.ors.length;i++){
            if(true){
                lcontent.addElement("OR "+m.ors[i].in1name+" "+m.ors[i].in2name+" "+m.ors[i].outname);
            }
        }
        for(int i=0;i<m.xors.length;i++){
            if(true){
                lcontent.addElement("XOR "+m.xors[i].in1name+" "+m.xors[i].in2name+" "+m.xors[i].outname);
            }
        }
        for(int i=0;i<m.nands.length;i++){
            if(true){
                lcontent.addElement("NAND "+m.nands[i].in1name+" "+m.nands[i].in2name+" "+m.nands[i].outname);
            }
        }
        for(int i=0;i<m.constants.length;i++){
            if(true){
                lcontent.addElement("CONSTANT "+m.constants[i].outname);
            }
        }
        for(int i=0;i<m.invs.length;i++){
            if(true){
                lcontent.addElement("INV "+m.invs[i].inname+" "+m.invs[i].outname);
            }
        }
        for(int i=0;i<m.bits.length;i++){
            if(true){
                lcontent.addElement("BIT "+m.bits[i].readname+" "+m.bits[i].setname+" "+m.bits[i].inname+" "+m.bits[i].outname);
            }
        }
        for(int i=0;i<m.plas.length;i++){
            if(true){
                lcontent.addElement("PLA "+m.plas[i].name);
            }
        }
        for(int i=0;i<m.outname.length;i++){
            if(true){
                lcontent.addElement("OUT "+m.outname[i]);
            }
        }
        l.setListData(lcontent);
    }
}
class AddedElems{
    String[]s=new String[0];
    public AddedElems(){
    }
    public void add(String str){
        int n=s.length;
        String[]s2=new String[n+1];
        for(int i=0;i<n;i++){
            s2[i]=s[i];
        }
        s2[n]=str;
        s=s2;
    }
    public boolean contained(String str){
        int n=s.length;
        for(int i=0;i<n;i++){
            if(s[i].equals(str)){
                return true;
            }
        }
        return false;
    }
}
class NcoreCreator extends JFrame implements Runnable,ActionListener{
    AstroChip astrochip;
    Module main;
    JLabel ncorelabel;
    JTextField ncoretextfield;
    JLabel membeginlabel;
    JTextField membegintextfield;
    JLabel memendlabel;
    JTextField memendtextfield;
    JLabel vgamemlabel;
    JTextField vgamemtextfield;
    JButton create;
    JTextArea result;
    JScrollPane spresult;
    boolean createb=false;
    Thread t;
    boolean running=true;
    private static final long serialVersionUID = -4976954881444321525L;
    public NcoreCreator(AstroChip astrochip,Module main){
        super("NcoreCreator");
        this.astrochip=astrochip;
        this.main=main;
        pack();
        setSize(640,480);
        setLayout(null);
        ncorelabel=new JLabel("number of cores: ");
        ncoretextfield=new JTextField("2");
        membeginlabel=new JLabel("first memory address: ");
        membegintextfield=new JTextField("0");
        memendlabel=new JLabel("last memory address: ");
        memendtextfield=new JTextField("1");
        vgamemlabel=new JLabel("vga memory size: ");
        vgamemtextfield=new JTextField("1");
        create=new JButton("create n cores");
        result=new JTextArea();
        spresult=new JScrollPane(result);
        add(ncorelabel);
        add(ncoretextfield);
        add(membeginlabel);
        add(membegintextfield);
        add(memendlabel);
        add(memendtextfield);
        add(vgamemlabel);
        add(vgamemtextfield);
        add(create);
        add(spresult);
        ncorelabel.setBounds(30,50,240,27);
        ncoretextfield.setBounds(300,50,240,27);
        membeginlabel.setBounds(30,80,240,27);
        membegintextfield.setBounds(300,80,240,27);
        memendlabel.setBounds(30,110,240,27);
        memendtextfield.setBounds(300,110,240,27);
        vgamemlabel.setBounds(30,140,240,27);
        vgamemtextfield.setBounds(300,140,240,27);
        create.setBounds(30,170,400,27);
        spresult.setBounds(30,230,500,180);
        create.addActionListener(this);
        result.append("Be careful with creating n cores! \n");
        result.append("Don't overwrite XPRO32.txt or XPRO32fast.txt! \n");
        result.append("You can only transform one to n cores. \n");
        result.append("The transformation is irreversible. \n\n");
        result.append("A version of XPRO32 must be loaded and build \n");
        result.append("in the AstroChip main window to use NcoreCreator. \n");
        setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
        setVisible(true);
        t=new Thread(this);
        t.start();
    }
    public void createmulticore(){
        if(main==null){
            result.append("failed: no compiled main file found\n");
            return;
        }
        int ncore=0;
        try{
            ncore=new Integer(ncoretextfield.getText()).intValue();
            if(ncore<2){
                result.append("failed: number of cores <2 ("+ncoretextfield.getText()+")\n");
                return;
            }
        }
        catch(Exception e1){
            result.append("failed: number of cores no integer ("+ncoretextfield.getText()+")\n");
            return;
        }
        int membegin=0;
        try{
            membegin=new Integer(membegintextfield.getText()).intValue();
            if(membegin<0){
                result.append("failed: memory start <0 ("+membegintextfield.getText()+")\n");
                return;
            }
        }
        catch(Exception e2){
            result.append("failed: memory start no integer ("+membegintextfield.getText()+")\n");
            return;
        }
        int memend=0;
        try{
            memend=new Integer(memendtextfield.getText()).intValue();
            if(memend<0){
                result.append("failed: last memory address <0 ("+memendtextfield.getText()+")\n");
                return;
            }
            if(memend<membegin){
                result.append("failed: last memory address < memory start ("+memendtextfield.getText()+"<"+membegintextfield.getText()+")\n");
                return;
            }
        }
        catch(Exception e3){
            result.append("failed: last memory address no integer ("+memendtextfield.getText()+")\n");
            return;
        }
        int vgamem=0;
        try{
            vgamem=new Integer(vgamemtextfield.getText()).intValue();
            if(vgamem<0){
                result.append("failed: vga memory size <0 ("+vgamemtextfield.getText()+")\n");
                return;
            }
            if(vgamem==0){
                result.append("failed: vga memory size must at least be 1 (your value: 0)\n");
                return;
            }
        }
        catch(Exception e4){
            result.append("failed: vga memory size no integer ("+vgamemtextfield.getText()+")\n");
            return;
        }
        JFileChooser fds=new JFileChooser();
        FileNameExtensionFilter filters=new FileNameExtensionFilter("TXT AstroChip definitions","txt");
        fds.setFileFilter(filters);
        int rets=fds.showSaveDialog(null);
        File f=null;
        String fname2=null;
        if(rets==JFileChooser.APPROVE_OPTION){
            f=fds.getSelectedFile();
            fname2=f.getAbsolutePath();
        }
        if(fname2==null){
            result.append("fileselect save error\n");
            return;
        }
        try{
            FileOutputStream fos=new FileOutputStream(fname2);
            PrintStream ps=new PrintStream(fos);
            String thesource=astrochip.ta.getText();
            int indexmemconstart=thesource.indexOf("MODULE MEMCON{");
            int indexmemconstartb=indexmemconstart;
            if(indexmemconstart==-1){
                indexmemconstartb=0;
            }
            int indexmemconend=thesource.indexOf("}",indexmemconstartb);
            if(indexmemconstart==-1){
                result.append("warning: MODULE MEMCON{ not found in source! \n");
            }
            else if(indexmemconend==-1){
                result.append("warning: } of MODULE MEMCON{ not found in source! \n");
            }
            else{
                String firstpart=thesource.substring(0,indexmemconstart);
                int srclen=thesource.length();
                if(indexmemconend<srclen-1){
                    String secondpart=thesource.substring(indexmemconend+1);
                    thesource=firstpart+secondpart;
                }
                else{
                    thesource=firstpart;
                }
            }
            int indexvmemconstart=thesource.indexOf("MODULE VIDEOMEMCON{");
            int indexvmemconstartb=indexvmemconstart;
            if(indexvmemconstart==-1){
                indexvmemconstartb=0;
            }
            int indexvmemconend=thesource.indexOf("}",indexvmemconstartb);
            if(indexvmemconstart==-1){
                result.append("warning: MODULE VIDEOMEMCON{ not found in source! \n");
            }
            else if(indexvmemconend==-1){
                result.append("warning: } of MODULE VIDEOMEMCON{ not found in source! \n");
            }
            else{
                String firstpart=thesource.substring(0,indexvmemconstart);
                int srclen=thesource.length();
                if(indexvmemconend<srclen-1){
                    String secondpart=thesource.substring(indexvmemconend+1);
                    thesource=firstpart+secondpart;
                }
                else{
                    thesource=firstpart;
                }
            }
            int index=thesource.indexOf("MODULE main{");
            if(index==-1){
                result.append("failed: MODULE main{ not found in source. \n");
                result.append("XPRO32 source and build main module \n");
                result.append("must be available in the AstroChip main window. \n");
                return;
            }
            int index2=thesource.indexOf("}",index);
            if(index2==-1){
                result.append("failed: } of MODULE main{ not found in source. \n");
                result.append("XPRO32 source and builded main module \n");
                result.append("must be available in the AstroChip main window. \n");
                return;
            }
            String firstpart=thesource.substring(0,index);
            ps.println(firstpart);
            int sourcelength=thesource.length();
            if(index2<sourcelength-1){
                String secondpart=thesource.substring(index2+1);
                ps.println(secondpart);
            }
            String[]args=new String[3];
            args[0]=""+membegin;
            args[1]=""+memend;
            args[2]=""+ncore;
            MemGeneratorNcore.memconcreate(ps,args);
            MemGeneratorNcore.memcreate(ps,args);
            String[]argsb=new String[3];
            argsb[0]="0";
            argsb[1]=""+(vgamem-1);
            argsb[2]=""+ncore;
            VideoMemGeneratorNcore.memconcreate(ps,argsb);
            VideoMemGeneratorNcore.memcreate(ps,argsb);
            ps.println("MODULE SETBUFFERSEL{");
            ps.println("CYCLE 0;");
            for(int k=0;k<ncore;k++){
                ps.println("IN displayrwsetcore"+(k+1)+"in;");
                ps.println("IN displayindexcore"+(k+1)+"in;");
                ps.println("IN rwindexcore"+(k+1)+"in;");
                ps.println("IN copiesbuffercore"+(k+1)+"in;");
            }
            ps.println("OUT displayrwseto;");
            ps.println("OUT displayindexo;");
            ps.println("OUT rwindexo;");
            ps.println("INV firstactiveinvin firstactiveinvout;");
            ps.println("AND secondisallowedandin1 secondisallowedandin2 secondisallowedandout;");
            ps.println("OR isactiveorcore2in1 isactiveorcore2in2 isactiveorcore2out;");
            for(int k=2;k<ncore;k++){
                ps.println("INV corekisallowedinv"+(k+1)+"in corekisallowedinv"+(k+1)+"out;");
                ps.println("AND corekisallowedandwants"+(k+1)+"in1 corekisallowedandwants"+(k+1)+"in2 corekisallowedandwants"+(k+1)+"out;");
                ps.println("OR isactiveorcore"+(k+1)+"in1 isactiveorcore"+(k+1)+"in2 isactiveorcore"+(k+1)+"out;");
            }
            for(int k=0;k<ncore;k++){
                ps.println("AND displayindexandcore"+(k+1)+"in1 displayindexandcore"+(k+1)+"in2 displayindexandcore"+(k+1)+"out;");
                ps.println("AND rwindexandcore"+(k+1)+"in1 rwindexandcore"+(k+1)+"in2 rwindexandcore"+(k+1)+"out;");
            }
            ps.println("VIDEOGLOBORN displayrwsetglob;");
            ps.println("VIDEOGLOBORN displayindexglob;");
            ps.println("VIDEOGLOBORN rwindexglob;");
            for(int k=0;k<ncore;k++){
                ps.println("INV copiesbufferinvcore"+(k+1)+"in copiesbufferinvcore"+(k+1)+"out;");
                ps.println("AND settingindicesand"+(k+1)+"in1 settingindicesand"+(k+1)+"in2 settingindicesand"+(k+1)+"out;");
            }
            for(int k=0;k<ncore;k++){
                ps.println("CONNECT copiesbuffercore"+(k+1)+"in copiesbufferinvcore"+(k+1)+"in;");
                ps.println("CONNECT copiesbufferinvcore"+(k+1)+"out settingindicesand"+(k+1)+"in1;");
                ps.println("CONNECT displayrwsetcore"+(k+1)+"in settingindicesand"+(k+1)+"in2;");
            }
            ps.println("CONNECT settingindicesand1out firstactiveinvin;");
            ps.println("CONNECT firstactiveinvout secondisallowedandin1;");
            ps.println("CONNECT settingindicesand2out secondisallowedandin2;");
            ps.println("CONNECT settingindicesand1out isactiveorcore2in1;");
            ps.println("CONNECT secondisallowedandout isactiveorcore2in2;");
            for(int k=2;k<ncore;k++){
                ps.println("CONNECT isactiveorcore"+k+"out corekisallowedinv"+(k+1)+"in;");
                ps.println("CONNECT settingindicesand"+(k+1)+"out corekisallowedandwants"+(k+1)+"in1;");
                ps.println("CONNECT corekisallowedinv"+(k+1)+"out corekisallowedandwants"+(k+1)+"in2;");
                ps.println("CONNECT isactiveorcore"+k+"out isactiveorcore"+(k+1)+"in1;");
                ps.println("CONNECT corekisallowedandwants"+(k+1)+"out isactiveorcore"+(k+1)+"in2;");
            }
            ps.println("CONNECT displayindexcore1in displayindexandcore1in1;");
            ps.println("CONNECT settingindicesand1out displayindexandcore1in2;");
            ps.println("CONNECT rwindexcore1in rwindexandcore1in1;");
            ps.println("CONNECT settingindicesand1out rwindexandcore1in2;");
            ps.println("CONNECT displayindexcore2in displayindexandcore2in1;");
            ps.println("CONNECT secondisallowedandout displayindexandcore2in2;");
            ps.println("CONNECT rwindexcore2in rwindexandcore2in1;");
            ps.println("CONNECT secondisallowedandout rwindexandcore2in2;");
            for(int k=2;k<ncore;k++){
                ps.println("CONNECT displayindexcore"+(k+1)+"in displayindexandcore"+(k+1)+"in1;");
                ps.println("CONNECT corekisallowedandwants"+(k+1)+"out displayindexandcore"+(k+1)+"in2;");
                ps.println("CONNECT rwindexcore"+(k+1)+"in rwindexandcore"+(k+1)+"in1;");
                ps.println("CONNECT corekisallowedandwants"+(k+1)+"out rwindexandcore"+(k+1)+"in2;");
            }
            for(int k=0;k<ncore;k++){
                ps.println("CONNECT displayrwsetcore"+(k+1)+"in displayrwsetglob.in"+(k+1)+";");
                ps.println("CONNECT displayindexandcore"+(k+1)+"out displayindexglob.in"+(k+1)+";");
                ps.println("CONNECT rwindexandcore"+(k+1)+"out rwindexglob.in"+(k+1)+";");
            }
            ps.println("CONNECT displayrwsetglob.out displayrwseto;");
            ps.println("CONNECT displayindexglob.out displayindexo;");
            ps.println("CONNECT rwindexglob.out rwindexo;");
            ps.println("}");
            ps.println("MODULE main{");
            ps.println("CYCLE 0;");
            for(int i=0;i<main.constants.length;i++){
                for(int k=0;k<ncore;k++){
                    ps.println("CONSTANT "+main.constants[i].outname+"core"+(k+1)+" "+main.constants[i].value+";");
                }
            }
            for(int i=0;i<main.bits.length;i++){
                for(int k=0;k<ncore;k++){
                    ps.println("BIT "+main.bits[i].inname+"core"+(k+1)+" "+main.bits[i].outname+"core"+(k+1)+" "+main.bits[i].readname+"core"+(k+1)+" "+main.bits[i].setname+"core"+(k+1)+" "+main.bits[i].value+";");
                }
            }
            for(int i=0;i<main.ors.length;i++){
                for(int k=0;k<ncore;k++){
                    ps.println("OR "+main.ors[i].in1name+"core"+(k+1)+" "+main.ors[i].in2name+"core"+(k+1)+" "+main.ors[i].outname+"core"+(k+1)+";");
                }
            }
            for(int i=0;i<main.ands.length;i++){
                for(int k=0;k<ncore;k++){
                    ps.println("AND "+main.ands[i].in1name+"core"+(k+1)+" "+main.ands[i].in2name+"core"+(k+1)+" "+main.ands[i].outname+"core"+(k+1)+";");
                }
            }
            for(int i=0;i<main.xors.length;i++){
                for(int k=0;k<ncore;k++){
                    ps.println("XOR "+main.xors[i].in1name+"core"+(k+1)+" "+main.xors[i].in2name+"core"+(k+1)+" "+main.xors[i].outname+"core"+(k+1)+";");
                }
            }
            for(int i=0;i<main.nands.length;i++){
                for(int k=0;k<ncore;k++){
                    ps.println("NAND "+main.nands[i].in1name+"core"+(k+1)+" "+main.nands[i].in2name+"core"+(k+1)+" "+main.nands[i].outname+"core"+(k+1)+";");
                }
            }
            for(int i=0;i<main.invs.length;i++){
                for(int k=0;k<ncore;k++){
                    ps.println("INV "+main.invs[i].inname+"core"+(k+1)+" "+main.invs[i].outname+"core"+(k+1)+";");
                }
            }
            AddedElems addedelems=new AddedElems();
            for(int i=0;i<main.modules.length;i++){
                String modulename=main.modules[i].name;
                if((modulename.equals("memcon"))||(modulename.equals("vmem"))||(modulename.equals("qvga"))||(modulename.equals("encoder"))||(modulename.equals("keyboardin"))){
                    ps.println(main.modules[i].typename+" "+modulename+";");
                }
                else{
                    for(int k=0;k<ncore;k++){
                        int mindex=modulename.indexOf("[");
                        int mindex2=modulename.indexOf("]");
                        if(mindex==-1||mindex2==-1){
                            ps.println(main.modules[i].typename+" "+modulename+"core"+(k+1)+";");
                        }
                        else{
                            String countstr=modulename.substring(mindex+1,mindex2);
                            String modulenamestart=modulename.substring(0,mindex);
                            String addedelem=modulenamestart+"core"+(k+1);
                            if(!addedelems.contained(addedelem)){
                                ps.println(main.modules[i].typename+" "+modulenamestart+"core"+(k+1)+"["+main.modules[i].modulearraysize+"];");
                                addedelems.add(addedelem);
                            }
                        }
                    }
                }
            }
            ps.println("SETBUFFERSEL setbuffersel;");
            for(int k=0;k<ncore;k++){
                ps.println("AND copyatobandsetbuffer"+(k+1)+"in1 copyatobandsetbuffer"+(k+1)+"in2 copyatobandsetbuffer"+(k+1)+"out;");
                ps.println("AND copybtoaandsetbuffer"+(k+1)+"in1 copybtoaandsetbuffer"+(k+1)+"in2 copybtoaandsetbuffer"+(k+1)+"out;");
            }
            ps.println("VIDEOGLOBORN copyatobglob;");
            ps.println("VIDEOGLOBORN copybtoaglob;");
            ps.println("VIDEOGLOBORN keyboardresets;");
            for(int k=0;k<ncore;k++){
                ps.println("INV buffercopyinvincore"+(k+1)+" buffercopyinvoutcore"+(k+1)+";");
                ps.println("AND nocopyandin1core"+(k+1)+" nocopyandin2core"+(k+1)+" nocopyandoutcore"+(k+1)+";");
            }
            ps.println("VIDEOGLOBORN nocopyglob;");
            ps.println("INV onlycopiesinvin onlycopiesinvout;");
            int nv=ncore;
            int[]bj=new int[32];
            for(int j=0;j<32;j++){
                bj[j]=nv%2;
                nv=nv/2;
            }
            int[][]bjb=new int[32][ncore];
            for(int k=0;k<ncore;k++){
                int nvb=k;
                for(int j=0;j<32;j++){
                    bjb[j][k]=nvb%2;
                    nvb=nvb/2;
                }
            }
            for(int i=0;i<main.cons.length;i++){
                String l=main.cons[i].left;
                String r=main.cons[i].right;
                if((!existsonlyonce(l))&&(!existsonlyonce(r))){
                    String[]connstr=new String[ncore];
                    boolean[]bitofcorenumber=new boolean[ncore];
                    for(int k=0;k<ncore;k++){
                        connstr[k]="CONNECT ";
                        bitofcorenumber[k]=false;
                    }
                    int rlen=r.length();
                    if(rlen>=16){
                        String namebase=r.substring(0,16);
                        if(namebase.equals("numberofcoresand")){
                            for(int j=1;j<=32;j++){
                                if(r.equals(namebase+j+"in2")){
                                    int bjvalue=bj[j-1];
                                    if(bjvalue==0){
                                        l="c";
                                    }
                                    else{
                                        l="d";
                                    }
                                }
                            }
                        }
                    }
                    boolean iscorenumber=false;
                    if(rlen>=13){
                        String namebase=r.substring(0,13);
                        if(namebase.equals("corenumberand")){
                            for(int j=1;j<=32;j++){
                                if(r.equals(namebase+j+"in2")){
                                    iscorenumber=true;
                                    for(int k=0;k<ncore;k++){
                                        int bjvalue=bjb[j-1][k];
                                        if(bjvalue==0){
                                            bitofcorenumber[k]=false;
                                        }
                                        else{
                                            bitofcorenumber[k]=true;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    int pointindex=l.indexOf(".");
                    int indexindex=l.indexOf("[");
                    int indexindex2=l.indexOf("]");
                    if(pointindex!=-1){
                        if(indexindex==-1||indexindex2==-1){
                            for(int k=0;k<ncore;k++){
                                connstr[k]=connstr[k]+l.substring(0,pointindex)+"core"+(k+1)+"."+l.substring(pointindex+1);
                            }
                        }
                        else{
                            String countstr=l.substring(indexindex+1,indexindex2);
                            String connstart=l.substring(0,indexindex);
                            for(int k=0;k<ncore;k++){
                                connstr[k]=connstr[k]+connstart+"core"+(k+1)+"["+countstr+"]."+l.substring(pointindex+1);
                            }
                        }
                    }
                    else{
                        for(int k=0;k<ncore;k++){
                            if(iscorenumber){
                                if(bitofcorenumber[k]){
                                    connstr[k]=connstr[k]+"dcore"+(k+1);
                                }
                                else{
                                    connstr[k]=connstr[k]+"ccore"+(k+1);
                                }
                            }
                            else{
                                connstr[k]=connstr[k]+l+"core"+(k+1);
                            }
                        }
                    }
                    int pointindexr=r.indexOf(".");
                    int indexindexr=r.indexOf("[");
                    int indexindexr2=r.indexOf("]");
                    if(pointindexr!=-1){
                        if(indexindexr==-1||indexindexr2==-1){
                            for(int k=0;k<ncore;k++){
                                connstr[k]=connstr[k]+" "+r.substring(0,pointindexr)+"core"+(k+1)+"."+r.substring(pointindexr+1);
                            }
                        }
                        else{
                            String countstr=r.substring(indexindexr+1,indexindexr2);
                            String connstart=r.substring(0,indexindexr);
                            for(int k=0;k<ncore;k++){
                                connstr[k]=connstr[k]+" "+connstart+"core"+(k+1)+"["+countstr+"]."+r.substring(pointindexr+1);
                            }
                        }
                    }
                    else{
                        for(int k=0;k<ncore;k++){
                            connstr[k]=connstr[k]+" "+r+"core"+(k+1);
                        }
                    }
                    for(int k=0;k<ncore;k++){
                        ps.println(connstr[k]+";");
                    }
                }
            }
            for(int k=0;k<ncore;k++){
                ps.println("CONNECT testandsetmemcore"+(k+1)+".out memcon.testandsetcore"+(k+1)+";");
                ps.println("CONNECT floatmemcore"+(k+1)+".reado memcon.readcore"+(k+1)+";");
                ps.println("CONNECT floatmemcore"+(k+1)+".writeo memcon.writecore"+(k+1)+";");
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT floatmemcore"+(k+1)+".readato"+j+" memcon.readat"+j+"core"+(k+1)+";");
                }
                for(int j=1;j<=6;j++){
                    ps.println("CONNECT memcon.readino"+(j+2)+"core"+(k+1)+" opcodecore"+(k+1)+".in"+j+";");
                }
                for(int j=1;j<=6;j++){
                    ps.println("CONNECT memcon.readino"+(j+10)+"core"+(k+1)+" regacore"+(k+1)+".in"+j+";");
                }
                for(int j=1;j<=6;j++){
                    ps.println("CONNECT memcon.readino"+(j+18)+"core"+(k+1)+" regbcore"+(k+1)+".in"+j+";");
                }
                for(int j=1;j<=6;j++){
                    ps.println("CONNECT memcon.readino"+(j+26)+"core"+(k+1)+" destinationcore"+(k+1)+".in"+j+";");
                }
                for(int j=1;j<=8;j++){
                    ps.println("CONNECT memcon.readino"+(j+8)+"core"+(k+1)+" pand"+j+"in2core"+(k+1)+";");
                }
                for(int j=1;j<=16;j++){
                    ps.println("CONNECT memcon.readino"+(j+8)+"core"+(k+1)+" qand"+j+"in2core"+(k+1)+";");
                }
                for(int j=1;j<=16;j++){
                    ps.println("CONNECT memcon.readino"+(j+8)+"core"+(k+1)+" rand"+j+"in2core"+(k+1)+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT memcon.readino"+j+"core"+(k+1)+" sand"+j+"in2core"+(k+1)+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT memcon.readino"+j+"core"+(k+1)+" testandsetand"+j+"in2core"+(k+1)+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT floatmemcore"+(k+1)+".readino"+j+" memcon.readin"+j+"core"+(k+1)+";");
                }
            }
            for(int k=0;k<ncore;k++){
                ps.println("CONNECT opcodecore"+(k+1)+".out44 vmem.readcore"+(k+1)+";");
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT vmem.readino"+j+"core"+(k+1)+" bvgaand"+j+"in1core"+(k+1)+";");
                }
                ps.println("CONNECT opcodecore"+(k+1)+".out24 vmem.writecore"+(k+1)+";");
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT regfacore"+(k+1)+".out"+j+" vmem.readin"+j+"core"+(k+1)+";");
                }
                for(int j=1;j<=16;j++){
                    ps.println("CONNECT regfbcore"+(k+1)+".out"+j+" vmem.readat"+j+"core"+(k+1)+";");
                }
                ps.println("CONNECT qvga.rwbitouto vmem.readat17core"+(k+1)+";");
                ps.println("CONNECT qvga.copyatobo vmem.readat18core"+(k+1)+";");
                ps.println("CONNECT qvga.copybtoao vmem.readat19core"+(k+1)+";");
                for(int j=20;j<=32;j++){
                    ps.println("CONNECT regfbcore"+(k+1)+".out"+j+" vmem.readat"+j+"core"+(k+1)+";");
                }
            }
            ps.println("CONNECT dcore1 vmem.vread;");
            for(int j=1;j<=32;j++){
                ps.println("CONNECT ccore1 vmem.vreadin"+j+";");
            }
            for(int j=1;j<=17;j++){
                ps.println("CONNECT qvga.vreado"+j+" vmem.vreadat"+j+";");
            }
            for(int j=18;j<=32;j++){
                ps.println("CONNECT ccore1 vmem.vreadat"+j+";");
            }
            for(int j=1;j<=32;j++){
                ps.println("CONNECT vmem.vreadino"+j+" encoder.in"+j+";");
            }
            for(int k=0;k<ncore;k++){
                ps.println("CONNECT opcodecore"+(k+1)+".out45 setbuffersel.displayrwsetcore"+(k+1)+"in;");
                ps.println("CONNECT regfacore"+(k+1)+".out1 setbuffersel.displayindexcore"+(k+1)+"in;");
                ps.println("CONNECT regfacore"+(k+1)+".out2 setbuffersel.rwindexcore"+(k+1)+"in;");
                ps.println("CONNECT buffercopyaborbaoutcore"+(k+1)+" setbuffersel.copiesbuffercore"+(k+1)+"in;");
                ps.println("CONNECT regfacore"+(k+1)+".out3 copyatobandsetbuffer"+(k+1)+"in1;");
                ps.println("CONNECT opcodecore"+(k+1)+".out45 copyatobandsetbuffer"+(k+1)+"in2;");
                ps.println("CONNECT regfacore"+(k+1)+".out4 copybtoaandsetbuffer"+(k+1)+"in1;");
                ps.println("CONNECT opcodecore"+(k+1)+".out45 copybtoaandsetbuffer"+(k+1)+"in2;");
                ps.println("CONNECT copyatobandsetbuffer"+(k+1)+"out copyatobglob.in"+(k+1)+";");
                ps.println("CONNECT copybtoaandsetbuffer"+(k+1)+"out copybtoaglob.in"+(k+1)+";");
            }
            ps.println("CONNECT setbuffersel.displayrwseto qvga.displayrwset;");
            ps.println("CONNECT setbuffersel.displayindexo qvga.displayindex;");
            ps.println("CONNECT setbuffersel.rwindexo qvga.rwindex;");
            ps.println("CONNECT copyatobglob.out qvga.copyatob;");
            ps.println("CONNECT copybtoaglob.out qvga.copybtoa;");
            for(int k=0;k<ncore;k++){
                ps.println("CONNECT buffercopyaborbaoutcore"+(k+1)+" buffercopyinvincore"+(k+1)+";");
                ps.println("CONNECT buffercopyinvoutcore"+(k+1)+" nocopyandin1core"+(k+1)+";");
                ps.println("CONNECT opcodecore"+(k+1)+".out45 nocopyandin2core"+(k+1)+";");
                ps.println("CONNECT nocopyandoutcore"+(k+1)+" nocopyglob.in"+(k+1)+";");
            }
            ps.println("CONNECT nocopyglob.out onlycopiesinvin;");
            ps.println("CONNECT onlycopiesinvout qvga.saveindices;");
            for(int j=1;j<=3;j++){
                ps.println("CONNECT qvga.cfilterout"+j+" encoder.cfilterout"+j+"in;");
            }
            for(int j=1;j<=6;j++){
                ps.println("CONNECT qvga.beatand"+j+"outo encoder.beatand"+j+"outin;");
            }
            for(int k=0;k<ncore;k++){
                ps.println("CONNECT opcodecore"+(k+1)+".out30 keyboardresets.in"+(k+1)+";");
            }
            ps.println("CONNECT keyboardresets.out keyboardin.reset;");
            for(int k=0;k<ncore;k++){
                for(int j=1;j<=7;j++){
                    ps.println("CONNECT keyboardin.out"+j+" tand"+j+"in2core"+(k+1)+";");
                }
                ps.println("CONNECT keyboardin.notyet tand8in2core"+(k+1)+";");
                ps.println("CONNECT keyboardin.changed tand9in2core"+(k+1)+";");
            }
            ps.println("}");
            fos.close();
            result.append("\nXPRO32NCORE written with "+ncore+" cores. \n\n");
        }
        catch(Exception fexc){
            fexc.printStackTrace(System.out);
            result.append("\nerror writing "+fname2+"\n");
        }
    }
    public boolean existsonlyonce(String s){
        int pointindex=s.indexOf(".");
        if(pointindex==-1){
            return false;
        }
        String s2=s.substring(0,pointindex);
        if((s2.equals("memcon"))||(s2.equals("vmem"))||(s2.equals("qvga"))||(s2.equals("encoder"))||(s2.equals("keyboardin"))){
            return true;
        }
        return false;
    }
    public void run(){
        while(running){
            try{
                Thread.sleep(100);
                if(createb){
                    createb=false;
                    createmulticore();
                }
            }
            catch(Exception e){
            }
        }
    }
    public void actionPerformed(ActionEvent evt){
        if(evt.getSource()==create){
            createb=true;
        }
    }
}
